const TYPE_UNDEFINED = "undefined";
const TYPE_OBJECT = "object";
const TYPE_BOOLEAN = "boolean";
const TYPE_STRING = "string";
const TYPE_NUMBER = "number";
const TYPE_INTEGER = "int";
const TYPE_FUNCTION = "function";

const STRING_TRUE = "true";
const STRING_FALSE = "false";

var modelData = {
	title: "Интерактивная карта (MapKit)",
	aCSS:["CHIMICESKAIA V MIRE_files/map_player/css/mapkit-common.css", "CHIMICESKAIA V MIRE_files/map_player/css/mapkit-ui.css"],
	
	imagesToPreload: [{id:"additional-icons", src:"CHIMICESKAIA V MIRE_files/map_player/css/mapkit-additional-icons.png"}, {id:"mapkit-player-interface-icons", src:"CHIMICESKAIA V MIRE_files/map_player/css/mapkit-player-interface-icons.png"}]
};
var objLoaderIndicator = {};
//
//mouse wheel should not scroll the window always: there might be elements with their own handlers
var mouse_wheel = function(event) {
	if (false == !!event) event = window.event;
	var objTarget = event.target, objCurr, obj, a = aElementPreventMouseWheel, i, l = a.length;
	if(typeof objTarget.parentNode != "undefined"){
		for(i=0; i<l; i++){
			obj = a[i];
			for(objCurr = objTarget; objCurr != null && objCurr != obj; objCurr = objCurr.parentNode){
			}
			if(objCurr != null)
				break;
		}
		if(i<l){
			if(typeof event.preventDefault != "undefined")
				event.preventDefault();
			return false;
		}
	}
};
var aElementPreventMouseWheel = [];
var addElementWithOwnMouseWheelHandler = function(obj){
	if(typeof obj.parentNode != "undefined" && aElementPreventMouseWheel.indexOf(obj) == -1)
		aElementPreventMouseWheel.push(obj);
};
var removeElementWithOwnMouseWheelHandler = function(obj){
	var i = aElementPreventMouseWheel.indexOf(obj);
	if(i == -1)
		aElementPreventMouseWheel.splice(i,1);
};
window.addEventListener("load", function() {
									if (typeof window.addEventListener != "undefined") window.addEventListener("DOMMouseScroll", mouse_wheel, false);
									window.onmousewheel = document.onmousewheel = mouse_wheel;
								});
//
(function(){
	var aaJSToLoad = [
		"CHIMICESKAIA V MIRE_files/map_player/js/script-0.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-1.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-2.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-3.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-4.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-5.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-6.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-7.js",
"CHIMICESKAIA V MIRE_files/map_player/js/script-8.js"
		];
	var iaJSToLoad = 0;
	
	function intermediateInit(){
		updateLoader();
		var a = aaJSToLoad[iaJSToLoad++];
		if(typeof a == "string")
			a = [a];
		Modernizr.load({nope:a, complete: (iaJSToLoad == aaJSToLoad.length) ? init : intermediateInit});
	}
	
	function updateLoader(){
		var n = aaJSToLoad.length;
		if(objLoaderIndicator.currentLoaderProgress == -1){
			loaderCanvas.style.display = "block";
			objLoaderIndicator.currentLoaderProgress = 0;
		}else{
			var i, objAT = objLoaderIndicator.objLoaderFragmentTransforms, ctx = objLoaderIndicator.loaderCtx, fragment = objLoaderIndicator.loaderFragmentCanvas;
			var nFrom = objLoaderIndicator.previousLoaderProgress, nTo = Math.floor(objLoaderIndicator.totalLoaderFragments*(iaJSToLoad*objLoaderIndicator.scriptLoaderShare/n));
			objLoaderIndicator.currentLoaderProgress = nTo;
			for(i=nFrom; i<nTo; i++){
				ctx.setTransform(objAT.aT1[i], objAT.aT2[i], objAT.aT3[i], objAT.aT4[i], objAT.aT5[i], objAT.aT6[i]);
				ctx.drawImage(fragment, 0, 0);
				ctx.setTransform(1, 0, 0, 1, 0, 0);
			}
		}
		objLoaderIndicator.previousLoaderProgress = objLoaderIndicator.currentLoaderProgress;
	}
	
	//========================================loader indicator initialization===========================
	objLoaderIndicator.loaderCanvas = document.createElement("CANVAS");
	objLoaderIndicator.loaderCtx = objLoaderIndicator.loaderCanvas.getContext("2d");
	objLoaderIndicator.loaderFragmentCanvas = document.createElement("CANVAS");
	objLoaderIndicator.objLoaderFragmentTransforms = {
														aT1:[1, 0.7071, 0, -0.7071, -1, -0.7071, 0, 0.7071], 
														aT2:[0, 0.7071, 1, 0.7071, 0, -0.7071, -1, -0.7071], 
														aT3:[0, -0.7071, -1, -0.7071, 0, 0.7071, 1, 0.7071], 
														aT4:[1, 0.7071, 0, -0.7071, -1, -0.7071, 0, 0.7071], 
														aT5:[50, 88, 112, 108, 77, 39, 15, 20], 
														aT6:[15, 20, 50, 89, 113, 108, 78, 39]
													};
	objLoaderIndicator.previousLoaderProgress = 0;
	objLoaderIndicator.currentLoaderProgress = -1;
	objLoaderIndicator.totalLoaderFragments = 8;
	objLoaderIndicator.scriptLoaderShare = 0.75;
									
	var loaderCanvas = 	objLoaderIndicator.loaderCanvas, loaderCtx = objLoaderIndicator.loaderCtx;
	loaderCanvas.id = "loaderCanvas";
	var grd = loaderCtx.createRadialGradient(59, 58, 2, 55, 56, 30);
	grd.addColorStop(0, "#FFEF00");
	grd.addColorStop(1, "#FFA90F");
	loaderCanvas.width = loaderCanvas.height = 128;
	loaderCtx.fillStyle = grd;
	loaderCtx.strokeStyle = "#AD3900";
	loaderCtx.lineWidth = 4;
	loaderCtx.arc(64, 64, 20, 0, 2*Math.PI);
	loaderCtx.fill();
	loaderCtx.stroke();
	loaderCanvas.style.position = "relative";
	loaderCanvas.style.marginLeft = "auto";
	loaderCanvas.style.marginRight = "auto";
	loaderCanvas.style.display = "none";
	document.body.appendChild(loaderCanvas);
	
	var fragmentCanvas = objLoaderIndicator.loaderFragmentCanvas, fragmentCtx = fragmentCanvas.getContext("2d");
	fragmentCanvas.width = 28;
	fragmentCanvas.height = 32;
	grd = fragmentCtx.createRadialGradient(21, 8, 2, 21, 8, 30);
	grd.addColorStop(0, "#8AE3FF");
	grd.addColorStop(1, "#BEEBF7");
	fragmentCtx.fillStyle = grd;
	fragmentCtx.strokeStyle = "#7C746F";
	fragmentCtx.lineWidth = 2;
	fragmentCtx.beginPath();
	fragmentCtx.moveTo(3, 16);
	fragmentCtx.bezierCurveTo(-3, -3, 30, -3, 24, 16);
	fragmentCtx.lineTo(21, 28);
	fragmentCtx.bezierCurveTo(16, 26, 12, 26, 7, 28);
	fragmentCtx.lineTo(3, 16);
	fragmentCtx.fill();
	fragmentCtx.stroke();
	//===================================================================================================
	
	//=======================================for asynchronously loaded resources. Object of flags========
	var objAsynchronousReadiness = {};
	objLoaderIndicator.setAsynchronousFlag = function(sId, flag){
		objAsynchronousReadiness[sId] = flag;
	};
	
	objLoaderIndicator.isAsynchronousReady = function(){
		var attr;
		for(attr in objAsynchronousReadiness)
			if(objAsynchronousReadiness[attr])
				return false;
		return true;
	};
	
	//load first part of JS-files
	intermediateInit();
	
	function init(){
		updateLoader();
		document.ondragstart = function() {return false};
 		document.body.onselectstart = function() {return false};
		//
		var modelMain = ModelMainInstance(modelData);
	}
})();