/**
 * @constructor
 */
function PointModelLibrary(){
    PointModelLibrary.superclass.constructor.call(this, PointModelLibrary.prototype.iconPartsStorage);
}
extend(PointModelLibrary, AbstractSVGLibrary);

PointModelLibrary.prototype.stockCanvas = null;
PointModelLibrary.prototype.stockColorCanvas = null;
PointModelLibrary.prototype.flagUseStockCanvases = true;
PointModelLibrary.prototype.DEFAULT_SYMBOL_ID = "unknown";

PointModelLibrary.prototype.iconPartsStorage = PointModelLibraryAssets.prototype.iconPartsStorage;

PointModelLibrary.prototype.nameIdMatches = [
    {id:"mcSymbol00_Size0", name:"common.circle.0"},
    {id:"mcSymbol00_Size1", name:"common.circle.1"},
    {id:"mcSymbol00_Size2", name:"common.circle.2"},

    {id:"mcSymbol01_Size0", name:"common.square.0"},
    {id:"mcSymbol01_Size1", name:"common.square.1"},
    {id:"mcSymbol01_Size2", name:"common.square.2"},

    {id:"mcSymbol02_Size0", name:"common.triangle.0"},
    {id:"mcSymbol02_Size1", name:"common.triangle.1"},
    {id:"mcSymbol02_Size2", name:"common.triangle.2"},

    {id:"mcSymbol03_Size0", name:"common.rhomb.0"},
    {id:"mcSymbol03_Size1", name:"common.rhomb.1"},
    {id:"mcSymbol03_Size2", name:"common.rhomb.2"},

    {id:"mcSymbol04_Size0", name:"common.rectangle.0"},
    {id:"mcSymbol04_Size1", name:"common.rectangle.1"},
    {id:"mcSymbol04_Size2", name:"common.rectangle.2"},

    {id:"mcSymbol05_Size0", name:"common.cross.0"},
    {id:"mcSymbol05_Size1", name:"common.cross.1"},
    {id:"mcSymbol05_Size2", name:"common.cross.2"},

    {id:"mcSymbol06_Size0", name:"common.star.0"},
    {id:"mcSymbol06_Size1", name:"common.star.1"},
    {id:"mcSymbol06_Size2", name:"common.star.2"},

    {id:"mcSymbol07_Size0", name:"common.flag.0"},
    {id:"mcSymbol07_Size1", name:"common.flag.1"},
    {id:"mcSymbol07_Size2", name:"common.flag.2"},

    {id:"mcSymbol08_Size0", name:"common.battle.0"},
    {id:"mcSymbol08_Size1", name:"common.battle.1"},
    {id:"mcSymbol08_Size2", name:"common.battle.2"},

    {id:"mcSymbol09_Size0", name:"common.fire.0"},
    {id:"mcSymbol09_Size1", name:"common.fire.1"},
    {id:"mcSymbol09_Size2", name:"common.fire.2"},

    {id:"mcSymbol10_Size0", name:"mineral.oil"},
    {id:"mcSymbol10_Size1", name:"mineral.electricity"},
    {id:"mcSymbol10_Size2", name:"mineral.natural-gas"},
    {id:"mcSymbol11_Size0", name:"mineral.brown-coal"},
    {id:"mcSymbol11_Size1", name:"mineral.coal"},
    {id:"mcSymbol11_Size2", name:"mineral.uranium"},
    {id:"mcSymbol12_Size0", name:"mineral.copper"},
    {id:"mcSymbol12_Size1", name:"mineral.iron"},
    {id:"mcSymbol12_Size2", name:"mineral.aluminium"},
    {id:"mcSymbol13_Size0", name:"mineral.molybdenum"},
    {id:"mcSymbol13_Size1", name:"mineral.nickel"},
    {id:"mcSymbol13_Size2", name:"mineral.tungsten"},
    {id:"mcSymbol14_Size0", name:"mineral.titanium"},
    {id:"mcSymbol14_Size1", name:"mineral.manganese"},
    {id:"mcSymbol14_Size2", name:"mineral.cobalt"},
    {id:"mcSymbol15_Size0", name:"mineral.mercury"},
    {id:"mcSymbol15_Size1", name:"mineral.tin"},
    {id:"mcSymbol15_Size2", name:"mineral.polymetal"},
    {id:"mcSymbol16_Size0", name:"mineral.gold"},
    {id:"mcSymbol16_Size1", name:"mineral.platinum"},
    {id:"mcSymbol16_Size2", name:"mineral.silver"},
    {id:"mcSymbol17_Size0", name:"mineral.apatite"},
    {id:"mcSymbol17_Size1", name:"mineral.phosphorite"},
    {id:"mcSymbol17_Size2", name:"mineral.sulphur"},
    {id:"mcSymbol18_Size0", name:"mineral.graphite"},
    {id:"mcSymbol18_Size1", name:"mineral.shale"},
    {id:"mcSymbol18_Size2", name:"mineral.diamonds"},
    {id:"mcSymbol19_Size0", name:"mineral.potassic-salt"},
    {id:"mcSymbol19_Size1", name:"mineral.salt"},
    {id:"mcSymbol19_Size2", name:"mineral.glauberSalt"},

    {id:"mcSymbolAN_Size0", name:"arrow.straight.0"},
    {id:"mcSymbolAN_Size1", name:"arrow.straight.1"},
    {id:"mcSymbolAN_Size2", name:"arrow.straight.2"},

    {id:"mcSymbolAP_Size0", name:"arrow.head-cloven.0"},
    {id:"mcSymbolAP_Size1", name:"arrow.head-cloven.1"},
    {id:"mcSymbolAP_Size2", name:"arrow.head-cloven.2"},

    {id:"mcSymbolAD_Size0", name:"arrow.straight-dashed.0"},
    {id:"mcSymbolAD_Size1", name:"arrow.straight-dashed.1"},
    {id:"mcSymbolAD_Size2", name:"arrow.straight-dashed.2"},

    {id:"mcSymbolAQ_Size0", name:"arrow.head-cloven-dashed.0"},
    {id:"mcSymbolAQ_Size1", name:"arrow.head-cloven-dashed.1"},
    {id:"mcSymbolAQ_Size2", name:"arrow.head-cloven-dashed.2"},

    {id:"mcSymbolAR_Size0", name:"arrow.wedge.0"},
    {id:"mcSymbolAR_Size1", name:"arrow.wedge.1"},
    {id:"mcSymbolAR_Size2", name:"arrow.wedge.2"},

    {id:"mcSymbolD0_Size0", name:"diagram.2.0"},
    {id:"mcSymbolD0_Size1", name:"diagram.2.1"},
    {id:"mcSymbolD0_Size2", name:"diagram.2.2"},
    {id:"mcSymbolD1_Size0", name:"diagram.3.0"},
    {id:"mcSymbolD1_Size1", name:"diagram.3.1"},
    {id:"mcSymbolD1_Size2", name:"diagram.3.2"},
    {id:"mcSymbolD2_Size0", name:"diagram.4.0"},
    {id:"mcSymbolD2_Size1", name:"diagram.4.1"},
    {id:"mcSymbolD2_Size2", name:"diagram.4.2"},
    {id:"mcSymbolD3_Size0", name:"diagram.5.0"},
    {id:"mcSymbolD3_Size1", name:"diagram.5.1"},
    {id:"mcSymbolD3_Size2", name:"diagram.5.2"},
    {id:"mcSymbolD4_Size0", name:"diagram.6.0"},
    {id:"mcSymbolD4_Size1", name:"diagram.6.1"},
    {id:"mcSymbolD4_Size2", name:"diagram.6.2"},

    {id:"mcSymbolRN_Size0", name:"rectangle.rectangle"},
    {id:"mcSymbolEN_Size0", name:"rectangle.ellipse"},

    {id:"mcFillColor",      name:"color.fill"},
    {id:"mcLineColor",      name:"color.line"},

    {id:"unknown", name:"common.question-mark"}
];

PointModelLibrary.prototype.iconStorage = [
    {
        name:"common.circle.0",
        hint:"common.circle.0.hint",
        width:20, height: 20, isEllipse:true,
        aPartId:["mcColor000", "mcHl000", "mcSel000"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor000", selectTarget: "mcSel000", highlightTarget: "mcHl000"
    },

    {
        name:"common.circle.1",
        hint:"common.circle.1.hint",
        width:8, height: 8, isEllipse:true,
        aPartId:["mcColor0001", "mcHl0001", "mcSel0001"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor0001", selectTarget: "mcSel0001", highlightTarget: "mcHl0001"
    },

    {
        name:"common.circle.2",
        hint:"common.circle.2.hint",
        width:32, height: 32, isEllipse:true,
        aPartId:["mcColor002", "mcHl002", "mcSel002"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor002", selectTarget: "mcSel002", highlightTarget: "mcHl002"
    },

    {
        name:"common.square.0",
        hint:"common.square.0.hint",
        width:20, height: 20, isEllipse:false,
        aPartId:["mcColor010", "mcHl010", "mcSel010"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor010", selectTarget: "mcSel010", highlightTarget: "mcHl010"
    },

    {
        name:"common.square.1",
        hint:"common.square.1.hint",
        width:8, height: 8, isEllipse:false,
        aPartId:["mcColor011", "mcHl011", "mcSel011"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor011", selectTarget: "mcSel011", highlightTarget: "mcHl011"
    },

    {
        name:"common.square.2",
        hint:"common.square.2.hint",
        width:32, height: 32, isEllipse:false,
        aPartId:["mcColor012", "mcHl012", "mcSel012"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor012", selectTarget: "mcSel012", highlightTarget: "mcHl012"
    },

    {
        name:"common.triangle.0",
        hint:"common.triangle.0.hint",
        width:20, height: 20, isEllipse:false,
        aPartId:["mcColor020", "mcHl020", "mcSel020"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor020", selectTarget: "mcSel020", highlightTarget: "mcHl020"
    },

    {
        name:"common.triangle.1",
        hint:"common.triangle.1.hint",
        width:8, height: 8, isEllipse:false,
        aPartId:["mcColor021", "mcHl021", "mcSel021"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor021", selectTarget: "mcSel021", highlightTarget: "mcHl021"
    },

    {
        name:"common.triangle.2",
        hint:"common.triangle.2.hint",
        width:32, height: 32, isEllipse:false,
        aPartId:["mcColor022", "mcHl022", "mcSel022"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor022", selectTarget: "mcSel022", highlightTarget: "mcHl022"
    },

    {
        name:"common.rhomb.0",
        hint:"common.rhomb.0.hint",
        width:20, height: 20, isEllipse:true,
        aPartId:["mcColor030", "mcHl030", "mcSel030"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor030", selectTarget: "mcSel030", highlightTarget: "mcHl030"
    },

    {
        name:"common.rhomb.1",
        hint:"common.rhomb.1.hint",
        width:8, height: 8, isEllipse:true,
        aPartId:["mcColor031", "mcHl031", "mcSel031"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor031", selectTarget: "mcSel031", highlightTarget: "mcHl031"
    },

    {
        name:"common.rhomb.2",
        hint:"common.rhomb.2.hint",
        width:32, height: 32, isEllipse:true,
        aPartId:["mcColor032", "mcHl032", "mcSel032"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor032", selectTarget: "mcSel032", highlightTarget: "mcHl032"
    },

    {
        name:"common.rectangle.0",
        hint:"common.rectangle.0.hint",
        width:20, height: 20, isEllipse:true,
        aPartId:["mcColor040", "mcHl040", "mcSel040"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor040", selectTarget: "mcSel040", highlightTarget: "mcHl040"
    },

    {
        name:"common.rectangle.1",
        hint:"common.rectangle.1.hint",
        width:8, height: 8, isEllipse:true,
        aPartId:["mcColor041", "mcHl041", "mcSel041"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor041", selectTarget: "mcSel041", highlightTarget: "mcHl041"
    },

    {
        name:"common.rectangle.2",
        hint:"common.rectangle.2.hint",
        width:32, height: 32, isEllipse:true,
        aPartId:["mcColor042", "mcHl042", "mcSel042"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor042", selectTarget: "mcSel042", highlightTarget: "mcHl042"
    },

    {
        name:"common.cross.0",
        hint:"common.cross.0.hint",
        width:20, height: 20, isEllipse:true,
        aPartId:["mcColor050", "mcHl050", "mcSel050"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor050", selectTarget: "mcSel050", highlightTarget: "mcHl050"
    },

    {
        name:"common.cross.1",
        hint:"common.cross.1.hint",
        width:8, height: 8, isEllipse:true,
        aPartId:["mcColor051", "mcHl051", "mcSel051"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor051", selectTarget: "mcSel051", highlightTarget: "mcHl051"
    },

    {
        name:"common.cross.2",
        hint:"common.cross.2.hint",
        width:32, height: 32, isEllipse:true,
        aPartId:["mcColor052", "mcHl052", "mcSel052"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor052", selectTarget: "mcSel052", highlightTarget: "mcHl052"
    },

    {
        name:"common.star.0",
        hint:"common.star.0.hint",
        width:20, height: 20, isEllipse:true,
        aPartId:["mcColor060", "mcHl060", "mcSel060"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor060", selectTarget: "mcSel060", highlightTarget: "mcHl060"
    },

    {
        name:"common.star.1",
        hint:"common.star.1.hint",
        width:8, height: 8, isEllipse:true,
        aPartId:["mcColor061", "mcHl061", "mcSel061"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor061", selectTarget: "mcSel061", highlightTarget: "mcHl061"
    },

    {
        name:"common.star.2",
        hint:"common.star.2.hint",
        width:32, height: 32, isEllipse:true,
        aPartId:["mcColor062", "mcHl062", "mcSel062"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor062", selectTarget: "mcSel062", highlightTarget: "mcHl062"
    },

    {
        name:"common.flag.0",
        hint:"common.flag.0.hint",
        width:24, height: 27, isEllipse:false,
        xShift:0, yShift:-5,
        aPartId:["mcColor070", "mcHl070", "mcSel070"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor070", selectTarget: "mcSel070", highlightTarget: "mcHl070"
    },

    {
        name:"common.flag.1",
        hint:"common.flag.1.hint",
        width:16, height: 24, isEllipse:false,
        xShift:0, yShift:-6,
        aPartId:["mcColor071", "mcHl071", "mcSel071"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor071", selectTarget: "mcSel071", highlightTarget: "mcHl071"
    },

    {
        name:"common.flag.2",
        hint:"common.flag.2.hint",
        width:30, height: 34, isEllipse:false,
        xShift:4, yShift:-10,
        aPartId:["mcColor072", "mcHl072", "mcSel072"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor072", selectTarget: "mcSel072", highlightTarget: "mcHl072"
    },

    {
        name:"common.battle.0",
        hint:"common.battle.0.hint",
        width:20, height:23, isEllipse:false,
        aPartId:["mcColor080", "mcHl080", "mcSel080"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor080", selectTarget: "mcSel080", highlightTarget: "mcHl080"
    },

    {
        name:"common.battle.1",
        hint:"common.battle.1.hint",
        width:20, height:20, isEllipse:false,
        aPartId:["mcColor081", "mcHl081", "mcSel081"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor081", selectTarget: "mcSel081", highlightTarget: "mcHl081"
    },

    {
        name:"common.battle.2",
        hint:"common.battle.2.hint",
        width:32, height:32, isEllipse:false,
        aPartId:["mcColor082", "mcHl082", "mcSel082"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor082", selectTarget: "mcSel082", highlightTarget: "mcHl082"
    },

    {
        name:"common.fire.0",
        hint:"common.fire.0.hint",
        width:20, height: 26, isEllipse:true,
        xShift:0, yShift:-6,
        aPartId:["mcColor090", "mcHl090", "mcSel090"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor090", selectTarget: "mcSel090", highlightTarget: "mcHl090"
    },

    {
        name:"common.fire.1",
        hint:"common.fire.1.hint",
        width:16, height: 20, isEllipse:true,
        xShift:0, yShift:-4,
        aPartId:["mcColor091", "mcHl091", "mcSel091"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor091", selectTarget: "mcSel091", highlightTarget: "mcHl091"
    },

    {
        name:"common.fire.2",
        hint:"common.fire.2.hint",
        width:26, height: 36, isEllipse:true,
        xShift:0, yShift:-10,
        aPartId:["mcColor092", "mcHl092", "mcSel092"],
        aScale:[1, 1, 1],
        colorTarget:"mcColor092", selectTarget: "mcSel092", highlightTarget: "mcHl092"
    },

    {
        name:"mineral.oil",
        hint:"mineral.oil.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grOil", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.electricity",
        hint:"mineral.electricity.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grElectricity", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.natural-gas",
        hint:"mineral.natural-gas.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grNaturalGas", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.brown-coal",
        hint:"mineral.brown-coal.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grBrownCoal", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.coal",
        hint:"mineral.coal.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grCoal", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.shale",
        hint:"mineral.shale.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grShale", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.copper",
        hint:"mineral.copper.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grCopper", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.iron",
        hint:"mineral.iron.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grIron", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.aluminium",
        hint:"mineral.aluminium.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grAluminium", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.molybdenum",
        hint:"mineral.molybdenum.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grMolybdenum", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.nickel",
        hint:"mineral.nickel.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grNickel", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.tungsten",
        hint:"mineral.tungsten.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grTungsten", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.titanium",
        hint:"mineral.titanium.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grTitanium", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.manganese",
        hint:"mineral.manganese.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grManganese", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.cobalt",
        hint:"mineral.cobalt.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grCobalt", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.diamonds",
        hint:"mineral.diamonds.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grDiamonds", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 0.25, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.mercury",
        hint:"mineral.mercury.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grMercury", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.tin",
        hint:"mineral.tin.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grTin", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.polymetal",
        hint:"mineral.polymetal.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grPolymetal", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.gold",
        hint:"mineral.gold.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grGold", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.platinum",
        hint:"mineral.platinum.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grPlatinum", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.silver",
        hint:"mineral.silver.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grSilver", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.apatite",
        hint:"mineral.apatite.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grApatite", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.phosphorite",
        hint:"mineral.phosphorite.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grPhosphorite", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.sulphur",
        hint:"mineral.sulphur.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grSulphur", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.graphite",
        hint:"mineral.graphite.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grGraphite", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.potassic-salt",
        hint:"mineral.potassic-salt.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grPotassicSalt", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.salt",
        hint:"mineral.salt.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grSalt", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.glauberSalt",
        hint:"mineral.glauberSalt.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grGlauberSalt", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"mineral.uranium",
        hint:"mineral.uranium.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grUranium", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    },

    {
        name:"arrow.straight.1",
        hint:"arrow.straight.1.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAN_Size1"],
        aScale:[1],
        colorTarget:"mcSymbolAN_Size1", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.straight.0",
        hint:"arrow.straight.0.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAN_Size0"],
        aScale:[1],
        colorTarget:"mcSymbolAN_Size0", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.straight.2",
        hint:"arrow.straight.2.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAN_Size2"],
        aScale:[1],
        colorTarget:"mcSymbolAN_Size2", selectTarget: null, highlightTarget: null
    },

    {
        name:"arrow.head-cloven.1",
        hint:"arrow.head-cloven.1.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAP_Size1"],
        aScale:[1],
        colorTarget:"mcSymbolAP_Size1", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.head-cloven.0",
        hint:"arrow.head-cloven.0.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAP_Size0"],
        aScale:[1],
        colorTarget:"mcSymbolAP_Size0", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.head-cloven.2",
        hint:"arrow.head-cloven.2.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAP_Size2"],
        aScale:[1],
        colorTarget:"mcSymbolAP_Size2", selectTarget: null, highlightTarget: null
    },

    {
        name:"arrow.straight-dashed.1",
        hint:"arrow.straight-dashed.1.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAD_Size1"],
        aScale:[1],
        colorTarget:"mcSymbolAD_Size1", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.straight-dashed.0",
        hint:"arrow.straight-dashed.0.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAD_Size0"],
        aScale:[1],
        colorTarget:"mcSymbolAD_Size0", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.straight-dashed.2",
        hint:"arrow.straight-dashed.2.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAD_Size2"],
        aScale:[1],
        colorTarget:"mcSymbolAD_Size2", selectTarget: null, highlightTarget: null
    },

    {
        name:"arrow.head-cloven-dashed.1",
        hint:"arrow.head-cloven-dashed.1.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAQ_Size1"],
        aScale:[1],
        colorTarget:"mcSymbolAQ_Size1", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.head-cloven-dashed.0",
        hint:"arrow.head-cloven-dashed.0.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAQ_Size0"],
        aScale:[1],
        colorTarget:"mcSymbolAQ_Size0", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.head-cloven-dashed.2",
        hint:"arrow.head-cloven-dashed.2.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAQ_Size2"],
        aScale:[1],
        colorTarget:"mcSymbolAQ_Size2", selectTarget: null, highlightTarget: null
    },

    {
        name:"arrow.wedge.1",
        hint:"arrow.wedge.1.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAR_Size1"],
        aScale:[1],
        colorTarget:"mcSymbolAR_Size1", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.wedge.0",
        hint:"arrow.wedge.0.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAR_Size0"],
        aScale:[1],
        colorTarget:"mcSymbolAR_Size0", selectTarget: null, highlightTarget: null
    },
    {
        name:"arrow.wedge.2",
        hint:"arrow.wedge.2.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["mcSymbolAR_Size2"],
        aScale:[1],
        colorTarget:"mcSymbolAR_Size2", selectTarget: null, highlightTarget: null
    },

    {
        name:"diagram.2.0",
        hint:"diagram.2.0.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD0_Size0"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.2.1",
        hint:"diagram.2.1.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD0_Size1"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.2.2",
        hint:"diagram.2.2.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD0_Size2"],
        aScale:[1],
        colorTarget:null
    },

    {
        name:"diagram.3.0",
        hint:"diagram.3.0.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD1_Size0"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.3.1",
        hint:"diagram.3.1.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD1_Size1"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.3.2",
        hint:"diagram.3.2.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD1_Size2"],
        aScale:[1],
        colorTarget:null
    },

    {
        name:"diagram.4.0",
        hint:"diagram.4.0.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD2_Size0"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.4.1",
        hint:"diagram.4.1.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD2_Size1"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.4.2",
        hint:"diagram.4.2.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD2_Size2"],
        aScale:[1],
        colorTarget:null
    },

    {
        name:"diagram.5.0",
        hint:"diagram.5.0.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD3_Size0"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.5.1",
        hint:"diagram.5.1.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD3_Size1"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.5.2",
        hint:"diagram.5.2.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD3_Size2"],
        aScale:[1],
        colorTarget:null
    },

    {
        name:"diagram.6.0",
        hint:"diagram.6.0.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD4_Size0"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.6.1",
        hint:"diagram.6.1.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD4_Size1"],
        aScale:[1],
        colorTarget:null
    },
    {
        name:"diagram.6.2",
        hint:"diagram.6.2.hint",
        width:36, height:36, isEllipse:false,
        aPartId:["mcSymbolD4_Size2"],
        aScale:[1],
        colorTarget:null
    },

    {
        name:"rectangle.rectangle",
        hint:"rectangle.rectangle.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["grRectangleColorTarget", "grRectangleLineColorTarget", "grRectangleCorners"],
        aScale:[1, 1, 1],
        //noColorTarget is shown in case color == undefined, instead of colorTarget
        colorTarget:["grRectangleColorTarget", "grRectangleCorners"], lineColorTarget:"grRectangleLineColorTarget", noColorTarget:"grColorButtonCross"
    },

    {
        name:"rectangle.ellipse",
        hint:"rectangle.ellipse.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["grEllipseColorTarget", "grEllipseLineColorTarget"],
        aScale:[1, 1],
        colorTarget:"grEllipseColorTarget", lineColorTarget:"grEllipseLineColorTarget"
    },

    {
        name:"color.fill",
        hint:"color.fill.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["grColorGrid", "grColorButtonCross", "mcFillColorTarget"],
        aScale:[1, 1, 1],
        colorTarget:"mcFillColorTarget", noColorTarget:"grColorButtonCross"
    },

    {
        name:"color.line",
        hint:"color.line.hint",
        width:28, height: 28, isEllipse:false,
        aPartId:["grLineColorGrid", "grColorButtonCross", "mcLineColorTarget"],
        aScale:[1, 1, 1],
        colorTarget:"mcLineColorTarget", noColorTarget:"grColorButtonCross"
    },

    {
        name:"common.question-mark",
        hint:"common.question-mark.hint",
        width:28, height: 28, isEllipse:true,
        aPartId:["mcColorMinerals", "grIconRingMinerals", "grQuestionMark", "mcHighlightMinerals", "mcSelectionMinerals"],
        aScale:[1, 1, 1, 1, 1],
        colorTarget:"mcColorMinerals", selectTarget:"mcSelectionMinerals", highlightTarget:"mcHighlightMinerals"
    }

];

//
PointModelLibrary.prototype.cachedObjects = [];

PointModelLibrary.prototype.makeSVG = function(data, c){
    if(typeof c != TYPE_UNDEFINED){
        var i = data.indexOf("\"filling\""), j;
        if(i!=-1){
            i = data.lastIndexOf("<", i);
            i = data.indexOf("fill=\"", i);
            j = data.indexOf("\"", i+6);
            data = data.slice(0, i+6).concat(""+c).concat(data.slice(j));
        }
    }
    var img = document.createElement("IMG");
    img.src = PointModelLibrary.prototype.srcSVGPrefix + window.btoa(data);

    return img;
};

//
PointModelLibrary.prototype.getCachedSVGSize = function(sId){
    var a = PointModelLibrary.prototype.iconPartsStorage, i, n = a.length;
    for (i = 0; i < n; i++)
        if (a[i].id == sId)
            return {width:a[i].width, height:a[i].height};
    return null;
};

PointModelLibrary.prototype.getNameById = function(sId){
    var i, n;
    var aMatch = PointModelLibrary.prototype.nameIdMatches;
    n = aMatch.length;
    for(i=0; i<n; i++)
        if(aMatch[i].id == sId)
            break;
    return (i<n) ? aMatch[i].name : null;
};

//override
PointModelLibrary.prototype.getSizeById = function(sId){
    var i;
    var sName= PointModelLibrary.prototype.getNameById(sId);
    if(sName == null)
        return PointModelLibrary.prototype.getSizeById(PointModelLibrary.prototype.DEFAULT_SYMBOL_ID);

    var a = PointModelLibrary.prototype.iconStorage;
    var n = a.length;
    for(i=0; i<n; i++)
        if(a[i].name == sName) {
            var obj = a[i];
            var objSize = {width: obj.width, height: obj.height, isEllipse: obj.isEllipse};
            objSize.xShift = (typeof obj.xShift == TYPE_NUMBER) ? obj.xShift : 0;
            objSize.yShift = (typeof obj.yShift == TYPE_NUMBER) ? obj.yShift : 0;
            return objSize;
        }
    return null;
};

PointModelLibrary.prototype.getDataById = function(sId){
    var i, j;
    var sName= PointModelLibrary.prototype.getNameById(sId);
    if(sName == null)
        return PointModelLibrary.prototype.getSizeById(PointModelLibrary.prototype.DEFAULT_SYMBOL_ID);

    var aCache = PointModelLibrary.prototype.cachedObjects;
    var n = aCache.length;
    for(i=0; i<n; i++)
        if(aCache[i].name == sName)
            return aCache[i];

    var a = PointModelLibrary.prototype.iconStorage;
    n = a.length;
    for(i=0; i<n; i++)
        if(a[i].name == sName)
            break;
    if(i==n)
        return null;

    var obj = a[i];
    var objPoint = {
        name: sName,
        hint:/*localization.getString*/obj.hint,
        colorTargetIndex:-1, lineColorTargetIndex:-1,
        noColorTargetIndex:-1,
        highlightTargetIndex:-1, selectTargetIndex:-1,
        aPart:[],
        aWidth:[],
        aHeight:[],
        aScale:obj.aScale.slice(0),
        aMinimalAlpha:(typeof obj.aMinimalAlpha != TYPE_UNDEFINED) && Array.isArray(obj.aMinimalAlpha) ? obj.aMinimalAlpha.slice(0) : null,
        xShift:(typeof obj.xShift == TYPE_NUMBER) ? obj.xShift : 0,
        yShift:(typeof obj.yShift == TYPE_NUMBER) ? obj.yShift : 0
    };
    var aPartId = obj.aPartId;
    n = aPartId.length;
    var aPart = objPoint.aPart;
    var aWidth = objPoint.aWidth;
    var aHeight = objPoint.aHeight;
    var objSize;
    var imgSVG;
    var sPartId;

    var aName = ["colorTarget", "noColorTarget", "lineColorTarget", "highlightTarget", "selectTarget"];
    var s, sInd;
    for(j=0; j<aName.length; j++){
        s = aName[j];
        sInd = s.concat("Index");
        if(Array.isArray(obj[s])){
            objPoint[sInd] = [];
            for(i=0; i<obj[s].length; i++)
                objPoint[sInd].push(aPartId.indexOf(obj[s][i]));
        }else
            objPoint[sInd] = (typeof obj[s] == TYPE_STRING) ? aPartId.indexOf(obj[s]) : -1;
    }

    for(i=0; i<n; i++) {
        sPartId = aPartId[i];
        imgSVG = PointModelLibrary.prototype.getCachedSVG(sPartId);
        aPart.push(imgSVG);
        objSize = PointModelLibrary.prototype.getCachedSVGSize(sPartId);
        aWidth.push(objSize.width);
        aHeight.push(objSize.height);
    }

    PointModelLibrary.prototype.cachedObjects.push(objPoint);

    return objPoint;
};

PointModelLibrary.prototype.makeCanvasByData = function(objPoint, _sc,
                                                        _color, _alpha,
                                                        _lineColor, _lineAlpha,
                                                        _highlightColor, _highlightAlpha,
                                                        flagSelect, flagShadow
){
    var sc = (typeof _sc == TYPE_NUMBER) ? _sc : 1.0;
    var flagColor = (typeof _color == TYPE_NUMBER && !isNaN(_color) && typeof _alpha == TYPE_NUMBER);
    var flagLineColor = (typeof _lineColor == TYPE_NUMBER && typeof _lineAlpha == TYPE_NUMBER);

    var aIColor = Array.isArray(objPoint.colorTargetIndex) ? objPoint.colorTargetIndex : [objPoint.colorTargetIndex];
    var flagIColor;
    var aINoColor = Array.isArray(objPoint.noColorTargetIndex) ? objPoint.noColorTargetIndex : [objPoint.noColorTargetIndex];
    var flagINoColor;
    var aILineColor = Array.isArray(objPoint.lineColorTargetIndex) ? objPoint.lineColorTargetIndex : [objPoint.lineColorTargetIndex];
    var flagILineColor;
    var aIHighlight = Array.isArray(objPoint.highlightTargetIndex) ? objPoint.highlightTargetIndex : [objPoint.highlightTargetIndex];
    var flagIHighlight;
    var aISelect = Array.isArray(objPoint.selectTargetIndex) ? objPoint.selectTargetIndex : [objPoint.selectTargetIndex];
    var flagISelect;

    var flagHighlightColor = (typeof _highlightColor == TYPE_NUMBER);
    var flagHighlightAlpha = (typeof _highlightAlpha == TYPE_NUMBER && _highlightAlpha != 0);

    var aPart = objPoint.aPart, i, n = aPart.length;
    var aScale = objPoint.aScale, scale;
    var aWidth = objPoint.aWidth;
    var aHeight = objPoint.aHeight;
    var img, w0 = 0, h0 = 0, w, h;

    var flagUseStockCanvas = PointModelLibrary.prototype.flagUseStockCanvases;

    for(i=0; i<n; i++){
        img = aPart[i];
        if(img==null)
            continue;
        w = aWidth[i]*aScale[i];
        h = aHeight[i]*aScale[i];
        if(w>w0)
            w0 = w;
        if(h>h0)
            h0 = h;
    }

    var cnv, ctx;
    var wCnv = Math.round(w0*sc)| 0;
    var hCnv = Math.round(h0*sc)| 0;

    if(flagUseStockCanvas){
        if(PointModelLibrary.prototype.stockCanvas == null)
            PointModelLibrary.prototype.stockCanvas = document.createElement("CANVAS");
        cnv = PointModelLibrary.prototype.stockCanvas;
        ctx = cnv.getContext("2d");
        if(cnv.width != wCnv || cnv.height != hCnv){
            cnv.width = wCnv;
            cnv.height = hCnv;
        }else
            ctx.clearRect(0, 0, cnv.width, cnv.height);

    }else {
        cnv = document.createElement("CANVAS");
        cnv.width = wCnv;
        cnv.height = hCnv;
        ctx = cnv.getContext("2d");
    }

    for(i=0; i<n; i++){
        //selectTarget is never shown in the player. Instead, highlight blinking is used to indicate selection
        flagIColor = aIColor.indexOf(i)!=-1;
        flagINoColor = aINoColor.indexOf(i)!=-1;
        flagILineColor = aILineColor.indexOf(i)!=-1;
        flagIHighlight = aIHighlight.indexOf(i)!=-1;
        flagISelect = aISelect.indexOf(i)!=-1;
        if(
            ((!flagHighlightColor || !flagHighlightAlpha) && flagIHighlight) ||
            (flagISelect && !flagSelect) ||
            (flagColor && flagINoColor)
        )
            continue;

        img = aPart[i];
        if(img==null)
            continue;
        //use masking to set color
        if((flagColor && flagIColor) || (flagLineColor && flagILineColor) || flagIHighlight){
            var cW = aWidth[i], cH = aHeight[i];
            var colorCnv;
            var colorCtx;

            if(flagUseStockCanvas){
                if(PointModelLibrary.prototype.stockColorCanvas == null)
                    PointModelLibrary.prototype.stockColorCanvas = document.createElement("CANVAS");
                colorCnv = PointModelLibrary.prototype.stockColorCanvas;
                colorCtx = colorCnv.getContext("2d");
                if(colorCnv.width != cW || colorCnv.height != cH){
                    colorCnv.width = cW;
                    colorCnv.height = cH;
                }else
                    colorCtx.clearRect(0, 0, cW, cH);
            }else{
                colorCnv = document.createElement("CANVAS");
                colorCnv.width = cW;
                colorCnv.height = cH;
                colorCtx = colorCnv.getContext("2d");
            }

            colorCtx.drawImage(img, 0, 0);
            colorCtx.globalCompositeOperation = "source-in";

            if(flagIHighlight)
                colorCtx.fillStyle = miscFunctions.intAlpha2RGBAFunction(_highlightColor, _highlightAlpha);
            if(flagIColor)
                colorCtx.fillStyle = miscFunctions.intAlpha2RGBAFunction(_color, _alpha);
            if(flagILineColor)
                colorCtx.fillStyle = miscFunctions.intAlpha2RGBAFunction(_lineColor, _lineAlpha);

            colorCtx.fillRect(0, 0, cW, cH);
            colorCtx.globalCompositeOperation = "source-over";
            img = colorCnv;
        }
        if((!flagShadow && (flagColor || !flagIColor)) || (flagShadow && flagColor && flagIColor)) {
            scale = aScale[i] * sc;
            ctx.setTransform(scale, 0, 0, scale, Math.round((wCnv - scale * aWidth[i]) / 2) | 0, Math.round((hCnv - scale * aHeight[i]) / 2) | 0);
            ctx.drawImage(img, 0, 0);
        }
    }
    ctx.setTransform(1, 0, 0, 1, 0, 0);

    return cnv;
};
/**
 * @constructor
 */
function MousePointerLibrary(){
    MousePointerLibrary.superclass.constructor.call(this, MousePointerLibrary.prototype.iconStorage);
}
extend(MousePointerLibrary, AbstractSVGLibrary);

MousePointerLibrary.prototype.toolPointerMatches = [
    {toolId:ModelTool.prototype.TOOL_SELECT,        pointerId:null},
    {toolId:ModelTool.prototype.TOOL_POINT,         pointerId:"mouse-pointer.tool.symbol"},
    {toolId:ModelTool.prototype.TOOL_ARROW,         pointerId:"mouse-pointer.tool.arrow"},
    {toolId:ModelTool.prototype.TOOL_POLYLINE,      pointerId:"mouse-pointer.tool.polyline"},
    {
        toolId:ModelTool.prototype.TOOL_RECTANGLE,
        pointerId:["mouse-pointer.tool.rectangle", "mouse-pointer.tool.ellipse"]
    },
    {toolId:ModelTool.prototype.TOOL_ELLIPSE,       pointerId:"mouse-pointer.tool.ellipse"},
    {toolId:ModelTool.prototype.TOOL_DIAGRAM,       pointerId:"mouse-pointer.tool.diagram"},
    {toolId:ModelTool.prototype.TOOL_CHECKBOX_SET,  pointerId:"mouse-pointer.tool.checkboxes"},
    {toolId:ModelTool.prototype.TOOL_TEXT,          pointerId:"mouse-pointer.tool.text"},
    {toolId:ModelTool.prototype.TOOL_BOUND_TEXT,    pointerId:"mouse-pointer.tool.btext"},
    {toolId:ModelTool.prototype.TOOL_PAN,           pointerId:"mouse-pointer.tool.pan"}
    ];

MousePointerLibrary.prototype.iconStorage = [
    {
        id:"mouse-pointer.scale.tl",
        xShift:-48, yShift:-48,
        data:'<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="96px"	 height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g id="Layer_4">	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M57.975,58.05l-0.05-3.975l-3.95,3.95L57.975,58.05z		 M35.975,35.925l10.8,0.1L42.85,39.95l13.175,13.2l3.85-3.851l0.15,10.8L49.175,60l4.025-4.025L40,42.8l-3.95,3.95L35.975,35.925z		 M42,37.975l-4-0.025l0.025,4L42,37.975z"/></g><g id="Layer_3">	<polygon fill-rule="evenodd" clip-rule="evenodd" points="44.4,37 41.425,39.95 56.025,54.55 58.925,51.65 59,59.075 		51.575,59.025 54.6,55.975 40,41.375 37.05,44.35 36.975,36.925 	"/></g></svg>'
    },
    {
        id:"mouse-pointer.scale.ml",
        xShift:-48, yShift:-48,
        data:'<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="96px"	 height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g id="Layer_4">	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M56.3,50.85l2.851-2.8l-2.851-2.8V50.85z M36.8,47.95l2.85,2.8		v-5.6L36.8,47.95z M54.3,45.95v-5.475l7.726,7.575L54.3,55.625V49.95H41.65v5.575l-7.725-7.575l7.725-7.575v5.575H54.3z"/></g><g id="Layer_3">	<polygon fill-rule="evenodd" clip-rule="evenodd" points="55.3,42.825 60.6,48.025 55.3,53.225 55.3,48.95 40.65,48.95 		40.65,53.15 35.35,47.95 40.65,42.75 40.65,46.95 55.3,46.95 	"/></g></svg>'
    },
    {
        id:"mouse-pointer.scale.bl",
        xShift:-48, yShift:-48,
        data:'<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="96px"	 height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g id="Layer_4">	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M38.025,58.05l0.05-3.975l3.95,3.95L38.025,58.05z M60.025,35.925		l-10.801,0.1l3.926,3.925l-13.175,13.2l-3.85-3.851l-0.15,10.8l10.85-0.1L42.8,55.975L56,42.8l3.95,3.95L60.025,35.925z M54,37.975		l4-0.025l-0.025,4L54,37.975z"/></g><g id="Layer_3">	<polygon fill-rule="evenodd" clip-rule="evenodd" points="51.6,37 54.575,39.95 39.975,54.55 37.075,51.65 37,59.075 		44.425,59.025 41.4,55.975 56,41.375 58.95,44.35 59.025,36.925 	"/></g></svg>'
    },
    {
        id:"mouse-pointer.scale.tm",
        xShift:-48, yShift:-48,
        data:'<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="96px"	 height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g id="Layer_4">	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M50.85,39.7l-2.8-2.85l-2.8,2.85H50.85z M47.95,59.2l2.8-2.851		h-5.6L47.95,59.2z M45.95,41.7h-5.475l7.575-7.725l7.575,7.725H49.95V54.35h5.575l-7.575,7.726l-7.575-7.726h5.575V41.7z"/></g><g id="Layer_3">	<polygon fill-rule="evenodd" clip-rule="evenodd" points="42.825,40.7 48.025,35.4 53.225,40.7 48.95,40.7 48.95,55.35 		53.15,55.35 47.95,60.65 42.75,55.35 46.95,55.35 46.95,40.7 	"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.polyline",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47.3,36.1c-0.2,0.066-0.3,0.133-0.3,0.2v7.4		c0,0.066,0.1,0.133,0.3,0.2c0.2,0.067,0.434,0.1,0.7,0.1s0.5-0.033,0.7-0.1c0.2-0.066,0.3-0.133,0.3-0.2v-7.4		c0-0.066-0.1-0.133-0.3-0.2C48.5,36.033,48.267,36,48,36S47.5,36.033,47.3,36.1z M46.6,35.65c0.4-0.1,0.867-0.15,1.4-0.15		s1,0.05,1.4,0.15c0.399,0.033,0.6,0.1,0.6,0.2v8.35c0,0.066-0.2,0.133-0.6,0.2c-0.4,0.067-0.867,0.1-1.4,0.1s-1-0.033-1.4-0.1		c-0.4-0.066-0.6-0.133-0.6-0.2v-8.35C46,35.75,46.2,35.683,46.6,35.65z M43.9,47.3c-0.066-0.2-0.133-0.3-0.2-0.3		c-2.467,0-4.934,0-7.4,0c-0.066,0-0.133,0.1-0.2,0.3C36.033,47.5,36,47.733,36,48s0.033,0.5,0.1,0.7c0.066,0.2,0.133,0.3,0.2,0.3		c2.467,0,4.934,0,7.4,0c0.066,0,0.133-0.1,0.2-0.3c0.067-0.2,0.1-0.434,0.1-0.7S43.967,47.5,43.9,47.3z M44.4,46.6		c0.067,0.4,0.1,0.867,0.1,1.4s-0.033,1-0.1,1.4C44.333,49.8,44.267,50,44.2,50c-2.8,0-5.583,0-8.35,0c-0.1,0-0.167-0.2-0.2-0.6		c-0.1-0.4-0.15-0.867-0.15-1.4s0.05-1,0.15-1.4c0.033-0.4,0.1-0.6,0.2-0.6c2.767,0,5.55,0,8.35,0C44.267,46,44.333,46.2,44.4,46.6z		 M48,46c0.533-0.067,1,0.067,1.4,0.4C49.8,46.9,50,47.433,50,48s-0.2,1.017-0.6,1.35C49,49.783,48.533,50,48,50		c-0.6,0-1.1-0.217-1.5-0.65C46.167,49.017,46,48.567,46,48s0.167-1.1,0.5-1.6C46.9,46.067,47.4,45.933,48,46z M47.3,48.7		c0.2,0.133,0.434,0.233,0.7,0.3c0.267-0.067,0.5-0.167,0.7-0.3c0.2-0.2,0.3-0.434,0.3-0.7s-0.1-0.5-0.3-0.7		c-0.2-0.2-0.434-0.267-0.7-0.2c-0.267-0.067-0.5,0-0.7,0.2C47.1,47.5,47,47.733,47,48S47.1,48.5,47.3,48.7z M52.1,48.7		c0.067,0.2,0.134,0.3,0.2,0.3h7.4c0.066,0,0.133-0.1,0.2-0.3c0.066-0.2,0.1-0.434,0.1-0.7s-0.033-0.5-0.1-0.7		c-0.067-0.2-0.134-0.3-0.2-0.3h-7.4c-0.066,0-0.133,0.1-0.2,0.3C52.033,47.5,52,47.733,52,48S52.033,48.5,52.1,48.7z M51.65,46.6		c0.033-0.4,0.1-0.6,0.199-0.6H60.2c0.066,0,0.133,0.2,0.2,0.6c0.066,0.4,0.1,0.867,0.1,1.4s-0.033,1-0.1,1.4		C60.333,49.8,60.267,50,60.2,50H51.85c-0.1,0-0.166-0.2-0.199-0.6C51.55,49,51.5,48.533,51.5,48S51.55,47,51.65,46.6z M47,52.3v7.4		c0,0.066,0.1,0.133,0.3,0.2c0.2,0.066,0.434,0.1,0.7,0.1s0.5-0.033,0.7-0.1c0.2-0.067,0.3-0.134,0.3-0.2v-7.4		c0-0.066-0.1-0.133-0.3-0.2C48.5,52.033,48.267,52,48,52s-0.5,0.033-0.7,0.1C47.1,52.167,47,52.233,47,52.3z M48,51.5		c0.533,0,1,0.05,1.4,0.15c0.399,0.033,0.6,0.1,0.6,0.199V60.2c0,0.066-0.2,0.133-0.6,0.2c-0.4,0.066-0.867,0.1-1.4,0.1		s-1-0.033-1.4-0.1c-0.4-0.067-0.6-0.134-0.6-0.2V51.85c0-0.1,0.2-0.166,0.6-0.199C47,51.55,47.467,51.5,48,51.5z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M47.3,36.1c0.2-0.067,0.434-0.1,0.7-0.1s0.5,0.033,0.7,0.1		c0.2,0.066,0.3,0.133,0.3,0.2v7.4c0,0.066-0.1,0.133-0.3,0.2C48.5,43.967,48.267,44,48,44s-0.5-0.033-0.7-0.1		c-0.2-0.066-0.3-0.133-0.3-0.2v-7.4C47,36.233,47.1,36.167,47.3,36.1z M43.9,47.3c0.067,0.2,0.1,0.434,0.1,0.7s-0.033,0.5-0.1,0.7		c-0.066,0.2-0.133,0.3-0.2,0.3c-2.467,0-4.934,0-7.4,0c-0.066,0-0.133-0.1-0.2-0.3C36.033,48.5,36,48.267,36,48s0.033-0.5,0.1-0.7		c0.066-0.2,0.133-0.3,0.2-0.3c2.467,0,4.934,0,7.4,0C43.767,47,43.833,47.1,43.9,47.3z M47.3,48.7C47.1,48.5,47,48.267,47,48		s0.1-0.5,0.3-0.7c0.2-0.2,0.434-0.267,0.7-0.2c0.267-0.067,0.5,0,0.7,0.2c0.2,0.2,0.3,0.434,0.3,0.7s-0.1,0.5-0.3,0.7		c-0.2,0.133-0.434,0.233-0.7,0.3C47.733,48.933,47.5,48.833,47.3,48.7z M52.1,48.7C52.033,48.5,52,48.267,52,48s0.033-0.5,0.1-0.7		c0.067-0.2,0.134-0.3,0.2-0.3h7.4c0.066,0,0.133,0.1,0.2,0.3c0.066,0.2,0.1,0.434,0.1,0.7s-0.033,0.5-0.1,0.7		c-0.067,0.2-0.134,0.3-0.2,0.3h-7.4C52.233,49,52.167,48.9,52.1,48.7z M47,52.3c0-0.066,0.1-0.133,0.3-0.2		c0.2-0.066,0.434-0.1,0.7-0.1s0.5,0.033,0.7,0.1c0.2,0.067,0.3,0.134,0.3,0.2v7.4c0,0.066-0.1,0.133-0.3,0.2		C48.5,59.967,48.267,60,48,60s-0.5-0.033-0.7-0.1c-0.2-0.067-0.3-0.134-0.3-0.2V52.3z"/></g></svg>'
    }
    ,
    {
        id: "mouse-pointer.tool.symbol",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47.4,48.35c-0.066-0.2-0.05-0.383,0.05-0.55		c0.066-0.2,0.183-0.333,0.35-0.4c0.167-0.066,0.351-0.083,0.55-0.05l7.7,1.75c0.167,0.034,0.316,0.134,0.45,0.301		c0.1,0.133,0.15,0.3,0.15,0.5c0,0.166-0.051,0.333-0.15,0.5c-0.1,0.133-0.233,0.233-0.4,0.3l-4.35,1.1l-1.05,4.25		c-0.066,0.167-0.167,0.3-0.3,0.4c-0.134,0.1-0.284,0.166-0.45,0.2c-0.2-0.034-0.384-0.101-0.55-0.2		c-0.134-0.101-0.217-0.25-0.25-0.45L47.4,48.35z M62.05,50.1l-2.6,5.051l-5.7,0.899l4.05,4.05L56.9,65.75l5.149-2.55l5.101,2.55		l-0.851-5.6l3.95-4.101l-5.6-0.899L62.05,50.1z M63.65,56.5l-1.601-3.1L60.4,56.5l-3.5,0.6l2.55,2.5l-0.601,3.5l3.2-1.55l3.2,1.55		l-0.55-3.5l2.5-2.5L63.65,56.5z M65.25,59.8l0.6,4.2l-3.8-1.9L58.2,64l0.7-4.2l-3.051-3.05l4.25-0.7l1.95-3.75L64,56.05l4.15,0.7		L65.25,59.8z M67.8,66.6l-5.75-2.8l-5.8,2.8l1.05-6.3l-4.6-4.55L59.1,54.7l2.95-5.65l2.9,5.65l6.3,1.05L66.8,60.3L67.8,66.6z		 M55.85,49.9l-7.699-1.75l1.8,7.7L51.1,51.15L55.85,49.9z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M62.05,50.1l2.601,5.051l5.6,0.899L66.3,60.15l0.851,5.6L62.05,63.2L56.9,65.75		L57.8,60.1l-4.05-4.05l5.7-0.899L62.05,50.1z M65.25,59.8l2.9-3.05L64,56.05l-1.95-3.75l-1.95,3.75l-4.25,0.7L58.9,59.8L58.2,64		l3.85-1.9l3.8,1.9L65.25,59.8z M55.85,49.9l-4.75,1.25L49.95,55.85l-1.8-7.7L55.85,49.9z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.arrow",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47.4,48.35c-0.066-0.2-0.05-0.383,0.05-0.55		c0.066-0.2,0.183-0.333,0.35-0.4c0.167-0.066,0.351-0.083,0.55-0.05l7.7,1.75c0.167,0.034,0.316,0.134,0.45,0.301		c0.1,0.133,0.15,0.3,0.15,0.5c0,0.166-0.051,0.333-0.15,0.5c-0.1,0.133-0.233,0.233-0.4,0.3l-4.35,1.1l-1.05,4.25		c-0.066,0.167-0.167,0.3-0.3,0.4c-0.134,0.1-0.284,0.166-0.45,0.2c-0.2-0.034-0.384-0.101-0.55-0.2		c-0.134-0.101-0.217-0.25-0.25-0.45L47.4,48.35z M61.7,50.9l-6.8,6.649c-0.067,0.066-0.117,0.167-0.15,0.3		c0,0.101,0.033,0.2,0.1,0.301c0.034,0.1,0.101,0.166,0.2,0.199C55.15,58.384,55.267,58.4,55.4,58.4l4.149-1.051L56.8,64.6		c-0.066,0.101-0.066,0.217,0,0.351c0.033,0.133,0.117,0.233,0.25,0.3c0.134,0.033,0.267,0.033,0.4,0L62,63.4l4.65,1.85		c0.1,0.033,0.216,0.017,0.35-0.05c0.134-0.033,0.217-0.117,0.25-0.25c0.066-0.134,0.083-0.25,0.05-0.351L64.5,57.4l4.15,1		c0.1,0,0.199-0.017,0.3-0.051c0.1-0.033,0.184-0.1,0.25-0.199c0.033-0.101,0.05-0.2,0.05-0.301c-0.033-0.133-0.083-0.233-0.15-0.3		L62.4,50.9c-0.101-0.101-0.217-0.15-0.351-0.15C61.917,50.75,61.8,50.8,61.7,50.9z M63.95,55.75l1.6,0.35l-3.5-3.449L58.6,56.05		l1.5-0.35c0.233-0.066,0.467-0.033,0.7,0.1c0.233,0.101,0.4,0.267,0.5,0.5c0.066,0.233,0.066,0.467,0,0.7L59,63l2.65-1.05		c0.233-0.101,0.483-0.101,0.75,0L65.05,63l-2.25-5.95c-0.1-0.233-0.1-0.467,0-0.7c0.066-0.233,0.217-0.399,0.45-0.5		C63.45,55.717,63.684,55.684,63.95,55.75z M62.05,50.25c0.267,0,0.5,0.1,0.7,0.3l6.7,6.65c0.166,0.166,0.267,0.366,0.3,0.6		c0.033,0.2,0,0.4-0.1,0.601c-0.134,0.199-0.301,0.35-0.5,0.449c-0.2,0.067-0.4,0.084-0.601,0.051L65.3,58.1l2.45,6.301		c0.1,0.267,0.1,0.517,0,0.75c-0.134,0.233-0.316,0.416-0.55,0.55c-0.267,0.1-0.517,0.1-0.75,0L62,63.95l-4.35,1.75		c-0.267,0.1-0.517,0.1-0.75,0c-0.267-0.134-0.45-0.316-0.551-0.55c-0.133-0.233-0.133-0.483,0-0.75l2.4-6.301L55.5,58.9		c-0.233,0.033-0.45,0.017-0.65-0.051C54.65,58.75,54.5,58.6,54.4,58.4c-0.134-0.2-0.184-0.417-0.15-0.65s0.134-0.417,0.3-0.55		l6.8-6.65C61.55,50.35,61.783,50.25,62.05,50.25z M63.5,56.25c-0.134,0.066-0.217,0.167-0.25,0.3c-0.066,0.101-0.066,0.217,0,0.351		l2.7,6.949L62.2,62.4c-0.134-0.067-0.25-0.067-0.351,0L58.15,63.85l2.699-7c0.034-0.133,0.034-0.25,0-0.35		c-0.066-0.134-0.149-0.233-0.25-0.3c-0.133-0.066-0.25-0.066-0.35,0L56.9,57l5.149-5.05l5.101,5.1l-3.301-0.8		C63.717,56.184,63.6,56.184,63.5,56.25z M55.85,49.9l-7.699-1.75l1.8,7.7L51.1,51.15L55.85,49.9z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M61.7,50.9c0.1-0.101,0.217-0.15,0.35-0.15c0.134,0,0.25,0.05,0.351,0.15		L69.1,57.55c0.067,0.066,0.117,0.167,0.15,0.3c0,0.101-0.017,0.2-0.05,0.301c-0.066,0.1-0.15,0.166-0.25,0.199		c-0.101,0.034-0.2,0.051-0.3,0.051l-4.15-1l2.8,7.199c0.033,0.101,0.017,0.217-0.05,0.351c-0.033,0.133-0.116,0.217-0.25,0.25		c-0.134,0.066-0.25,0.083-0.35,0.05L62,63.4l-4.55,1.85c-0.134,0.033-0.267,0.033-0.4,0c-0.133-0.066-0.217-0.167-0.25-0.3		c-0.066-0.134-0.066-0.25,0-0.351l2.75-7.25L55.4,58.4c-0.134,0-0.25-0.017-0.351-0.051c-0.1-0.033-0.166-0.1-0.2-0.199		c-0.066-0.101-0.1-0.2-0.1-0.301c0.033-0.133,0.083-0.233,0.15-0.3L61.7,50.9z M55.85,49.9l-4.75,1.25L49.95,55.85l-1.8-7.7		L55.85,49.9z M63.5,56.25c0.1-0.066,0.217-0.066,0.35,0l3.301,0.8l-5.101-5.1L56.9,57l3.35-0.8c0.1-0.066,0.217-0.066,0.35,0		c0.101,0.066,0.184,0.166,0.25,0.3c0.034,0.1,0.034,0.217,0,0.35l-2.699,7L61.85,62.4c0.101-0.067,0.217-0.067,0.351,0l3.75,1.449		l-2.7-6.949c-0.066-0.134-0.066-0.25,0-0.351C63.283,56.417,63.366,56.316,63.5,56.25z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.pan",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M48,39.45c0-0.2,0.017-0.4,0.05-0.6		c0.233-0.934,0.8-1.483,1.7-1.65c0.167,0.033,0.333,0.117,0.5,0.25c0.167,0.1,0.25,0.233,0.25,0.4c0.233,3.133,0.184,6.3-0.15,9.5		l0.2-0.05c0.9-1.767,1.533-3.617,1.9-5.55c0.133-0.667,0.3-1.3,0.5-1.9c0.2-0.733,0.7-1.017,1.5-0.85		c0.633,0.367,0.883,0.967,0.75,1.8c-0.334,1.667-0.667,3.317-1,4.95c-0.101,0.4-0.233,0.8-0.4,1.2c-0.366,0.7-0.517,1.45-0.45,2.25		l0.4,0.2c0.467-0.4,0.9-0.851,1.3-1.351c0.267-0.333,0.5-0.65,0.7-0.95c0.5-1.1,1.066-2.133,1.7-3.1l0.8-0.1		c0.167,0.1,0.316,0.233,0.45,0.4c0.1,0.133,0.149,0.3,0.149,0.5c-0.033,0.967-0.267,1.883-0.699,2.75c-1,1.867-2.15,3.634-3.45,5.3		c-0.033,1.4-0.3,2.717-0.8,3.95c-0.233,0.5-0.467,1.017-0.7,1.55c-0.4,0.834-1.033,1.384-1.9,1.65c-0.1,0.033-0.2,0.05-0.3,0.05		c-1.866-0.233-3.75-0.45-5.65-0.649c-0.567-0.034-1.067-0.2-1.5-0.5c-0.2-0.167-0.367-0.351-0.5-0.551		c-0.867-1.233-1.617-2.517-2.25-3.85c-0.233-0.5-0.5-0.967-0.8-1.4c-0.9-1.433-1.933-2.783-3.1-4.05		c-0.267-0.267-0.434-0.566-0.5-0.9c-0.133-0.467-0.1-0.9,0.1-1.3c0.233-0.5,0.617-0.633,1.15-0.4c1.466,0.533,2.583,1.5,3.35,2.899		c0.333,0.601,0.817,1.017,1.45,1.25L42.8,50.7l0.45,0.149c0.2-0.566,0.3-1.133,0.3-1.699c-0.033-0.267-0.083-0.534-0.15-0.8		c-0.733-2.133-1.2-4.317-1.4-6.55c-0.033-0.5-0.05-0.983-0.05-1.45c0-0.733,0.383-1.217,1.15-1.45c0.267,0.1,0.517,0.25,0.75,0.45		c0.2,0.2,0.333,0.45,0.4,0.75c0.5,2.5,1.217,4.95,2.15,7.35l0.75-0.2c0.067-0.733,0.15-1.467,0.25-2.2		C47.633,43.183,47.833,41.317,48,39.45z"/>			<path fill-rule="evenodd" clip-rule="evenodd" fill="none" stroke="#000000" stroke-linecap="round" stroke-linejoin="round" stroke-miterlimit="3" stroke-opacity="0.6" d="		M48,39.45c-0.167,1.867-0.367,3.733-0.6,5.6c-0.1,0.733-0.183,1.467-0.25,2.2l-0.75,0.2c-0.933-2.4-1.65-4.85-2.15-7.35		c-0.067-0.3-0.2-0.55-0.4-0.75c-0.233-0.2-0.483-0.35-0.75-0.45c-0.767,0.233-1.15,0.717-1.15,1.45c0,0.467,0.017,0.95,0.05,1.45		c0.2,2.233,0.667,4.417,1.4,6.55c0.067,0.267,0.117,0.533,0.15,0.8c0,0.566-0.1,1.133-0.3,1.699L42.8,50.7L42.75,50.6		c-0.633-0.233-1.117-0.649-1.45-1.25c-0.767-1.399-1.883-2.366-3.35-2.899c-0.534-0.233-0.917-0.1-1.15,0.4		c-0.2,0.4-0.233,0.833-0.1,1.3c0.066,0.333,0.233,0.633,0.5,0.9c1.167,1.267,2.2,2.617,3.1,4.05c0.3,0.434,0.567,0.9,0.8,1.4		c0.633,1.333,1.383,2.616,2.25,3.85c0.133,0.2,0.3,0.384,0.5,0.551c0.433,0.3,0.933,0.466,1.5,0.5		c1.9,0.199,3.784,0.416,5.65,0.649c0.1,0,0.2-0.017,0.3-0.05c0.867-0.267,1.5-0.816,1.9-1.65c0.233-0.533,0.467-1.05,0.7-1.55		c0.5-1.233,0.767-2.55,0.8-3.95c1.3-1.666,2.45-3.433,3.45-5.3c0.433-0.867,0.666-1.783,0.699-2.75c0-0.2-0.05-0.367-0.149-0.5		c-0.134-0.167-0.283-0.3-0.45-0.4l-0.8,0.1c-0.634,0.967-1.2,2-1.7,3.1c-0.2,0.3-0.434,0.617-0.7,0.95		c-0.399,0.5-0.833,0.95-1.3,1.351l-0.4-0.2c-0.066-0.8,0.084-1.55,0.45-2.25c0.167-0.4,0.3-0.8,0.4-1.2		c0.333-1.633,0.666-3.283,1-4.95c0.133-0.833-0.117-1.433-0.75-1.8c-0.8-0.167-1.3,0.117-1.5,0.85c-0.2,0.6-0.367,1.233-0.5,1.9		c-0.367,1.933-1,3.783-1.9,5.55l-0.2,0.05c0.334-3.2,0.384-6.367,0.15-9.5c0-0.167-0.083-0.3-0.25-0.4		c-0.167-0.133-0.333-0.217-0.5-0.25c-0.9,0.167-1.467,0.716-1.7,1.65C48.017,39.05,48,39.25,48,39.45z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.rectangle",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47.4,48.35c-0.066-0.2-0.05-0.383,0.05-0.55		c0.066-0.2,0.183-0.333,0.35-0.4c0.167-0.066,0.351-0.083,0.55-0.05l7.7,1.75c0.167,0.034,0.316,0.134,0.45,0.301		c0.1,0.133,0.15,0.3,0.15,0.5c0,0.166-0.051,0.333-0.15,0.5c-0.1,0.133-0.233,0.233-0.4,0.3l-4.35,1.1l-1.05,4.25		c-0.066,0.167-0.167,0.3-0.3,0.4c-0.134,0.1-0.284,0.166-0.45,0.2c-0.2-0.034-0.384-0.101-0.55-0.2		c-0.134-0.101-0.217-0.25-0.25-0.45L47.4,48.35z M69.5,62h-15v-8h15V62z M70.5,53h-17v10h17V53z M69,61.5v-7H55v7H69z M70,52.5		c0.267,0,0.5,0.1,0.7,0.3s0.3,0.434,0.3,0.7v9c0,0.267-0.1,0.5-0.3,0.7s-0.434,0.3-0.7,0.3H54c-0.267,0-0.5-0.1-0.7-0.3		S53,62.767,53,62.5v-9c0-0.267,0.1-0.5,0.3-0.7s0.434-0.3,0.7-0.3H70z M55.85,49.9l-7.699-1.75l1.8,7.7L51.1,51.15L55.85,49.9z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M70.5,53v10h-17V53H70.5z M69.5,62v-8h-15v8H69.5z M55.85,49.9l-4.75,1.25		L49.95,55.85l-1.8-7.7L55.85,49.9z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.ellipse",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47.4,48.35c-0.066-0.2-0.05-0.383,0.05-0.55		c0.066-0.2,0.183-0.333,0.35-0.4c0.167-0.066,0.351-0.083,0.55-0.05l7.7,1.75c0.167,0.034,0.316,0.134,0.45,0.301		c0.1,0.133,0.15,0.3,0.15,0.5c0,0.166-0.051,0.333-0.15,0.5c-0.1,0.133-0.233,0.233-0.4,0.3l-4.35,1.1l-1.05,4.25		c-0.066,0.167-0.167,0.3-0.3,0.4c-0.134,0.1-0.284,0.166-0.45,0.2c-0.2-0.034-0.384-0.101-0.55-0.2		c-0.134-0.101-0.217-0.25-0.25-0.45L47.4,48.35z M67.95,54.3C66.283,53.4,64.3,52.967,62,53c-2.3-0.033-4.267,0.417-5.9,1.35		c-1.767,1-2.633,2.217-2.6,3.65c-0.033,1.434,0.833,2.634,2.6,3.6C57.733,62.533,59.7,63,62,63s4.283-0.467,5.95-1.4		c1.733-1,2.583-2.199,2.55-3.6c0.033-1.434-0.816-2.65-2.55-3.65V54.3z M62,52.5h0.05c2.367-0.033,4.417,0.434,6.15,1.4		c1.934,1.133,2.866,2.5,2.8,4.1c0.066,1.6-0.866,2.95-2.8,4.05c-1.733,0.967-3.8,1.45-6.2,1.45s-4.45-0.483-6.15-1.45H55.9		c-2-1.1-2.967-2.45-2.9-4.05c-0.066-1.634,0.884-3,2.85-4.1H55.9C57.566,52.934,59.6,52.467,62,52.5z M67.2,55.65h0.05		c-1.467-0.801-3.2-1.184-5.2-1.15H62c-2.033-0.033-3.75,0.35-5.15,1.15C55.684,56.316,55.066,57.1,55,58		c0.066,0.866,0.684,1.634,1.85,2.3c1.434,0.8,3.15,1.2,5.15,1.2s3.733-0.4,5.2-1.2c1.133-0.666,1.733-1.434,1.8-2.3		C68.967,57.1,68.366,56.316,67.2,55.65z M67.45,60.75C65.917,61.583,64.1,62,62,62s-3.9-0.417-5.4-1.25		c-1.366-0.767-2.066-1.684-2.1-2.75c0.033-1.1,0.733-2.033,2.1-2.8c1.5-0.834,3.301-1.233,5.4-1.2c2.1-0.033,3.917,0.366,5.45,1.2		c1.333,0.767,2.017,1.7,2.05,2.8C69.467,59.066,68.783,59.983,67.45,60.75z M55.85,49.9l-7.699-1.75l1.8,7.7L51.1,51.15L55.85,49.9		z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M67.95,54.3v0.05c1.733,1,2.583,2.217,2.55,3.65c0.033,1.4-0.816,2.6-2.55,3.6		C66.283,62.533,64.3,63,62,63s-4.267-0.467-5.9-1.4c-1.767-0.966-2.633-2.166-2.6-3.6c-0.033-1.434,0.833-2.65,2.6-3.65		C57.733,53.417,59.7,52.967,62,53C64.3,52.967,66.283,53.4,67.95,54.3z M55.85,49.9l-4.75,1.25L49.95,55.85l-1.8-7.7L55.85,49.9z		 M67.45,60.75c1.333-0.767,2.017-1.684,2.05-2.75c-0.033-1.1-0.717-2.033-2.05-2.8C65.917,54.366,64.1,53.967,62,54		c-2.1-0.033-3.9,0.366-5.4,1.2c-1.366,0.767-2.066,1.7-2.1,2.8c0.033,1.066,0.733,1.983,2.1,2.75C58.1,61.583,59.9,62,62,62		S65.917,61.583,67.45,60.75z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.diagram",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47.4,48.35c-0.066-0.2-0.05-0.383,0.05-0.55		c0.066-0.2,0.183-0.333,0.35-0.4c0.167-0.066,0.351-0.083,0.55-0.05l7.7,1.75c0.167,0.034,0.316,0.134,0.45,0.301		c0.1,0.133,0.15,0.3,0.15,0.5c0,0.166-0.051,0.333-0.15,0.5c-0.1,0.133-0.233,0.233-0.4,0.3l-4.35,1.1l-1.05,4.25		c-0.066,0.167-0.167,0.3-0.3,0.4c-0.134,0.1-0.284,0.166-0.45,0.2c-0.2-0.034-0.384-0.101-0.55-0.2		c-0.134-0.101-0.217-0.25-0.25-0.45L47.4,48.35z M61.05,51.85H61c-1.967,0-3.65,0.7-5.05,2.101c-1.4,1.399-2.101,3.083-2.101,5.05		s0.7,3.65,2.101,5.05c1.399,1.4,3.083,2.101,5.05,2.101s3.65-0.7,5.05-2.101c1.4-1.399,2.101-3.066,2.101-5V59		c0-1.967-0.7-3.65-2.101-5.05C64.65,52.55,62.983,51.85,61.05,51.85z M61,51.35h0.05c2.066,0,3.851,0.75,5.351,2.25		s2.25,3.301,2.25,5.4v0.05c0,2.066-0.75,3.851-2.25,5.351S63.1,66.65,61,66.65s-3.9-0.75-5.4-2.25S53.35,61.1,53.35,59		s0.75-3.9,2.25-5.4S58.9,51.35,61,51.35z M67.15,59.5c-0.134,1.5-0.733,2.783-1.801,3.85C64.15,64.55,62.7,65.15,61,65.15		s-3.15-0.601-4.35-1.801C55.45,62.15,54.85,60.7,54.85,59s0.601-3.15,1.801-4.35c1.1-1.067,2.383-1.65,3.85-1.75V59		c0,0.134,0.05,0.25,0.15,0.35c0.1,0.101,0.216,0.15,0.35,0.15H67.15z M66.6,60H61c-0.267,0-0.5-0.1-0.7-0.3S60,59.267,60,59v-5.55		c-1.134,0.166-2.134,0.684-3,1.55c-1.1,1.1-1.65,2.434-1.65,4S55.9,61.9,57,63s2.434,1.65,4,1.65S63.9,64.1,65,63		C65.866,62.134,66.4,61.134,66.6,60z M55.85,49.9l-7.699-1.75l1.8,7.7L51.1,51.15L55.85,49.9z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M61.05,51.85c1.934,0,3.601,0.7,5,2.101c1.4,1.399,2.101,3.083,2.101,5.05v0.05		c0,1.934-0.7,3.601-2.101,5c-1.399,1.4-3.083,2.101-5.05,2.101s-3.65-0.7-5.05-2.101c-1.4-1.399-2.101-3.083-2.101-5.05		s0.7-3.65,2.101-5.05c1.399-1.4,3.083-2.101,5.05-2.101H61.05z M65.35,54.65C64.283,53.583,63,53,61.5,52.9v5.6h5.65		C67.017,57.033,66.417,55.75,65.35,54.65z M67.15,59.5H61c-0.134,0-0.25-0.05-0.35-0.15c-0.101-0.1-0.15-0.216-0.15-0.35v-6.1		c-1.467,0.1-2.75,0.683-3.85,1.75C55.45,55.85,54.85,57.3,54.85,59s0.601,3.15,1.801,4.35C57.85,64.55,59.3,65.15,61,65.15		s3.15-0.601,4.35-1.801C66.417,62.283,67.017,61,67.15,59.5z M55.85,49.9l-4.75,1.25L49.95,55.85l-1.8-7.7L55.85,49.9z"/>	<path fill-rule="evenodd" clip-rule="evenodd" fill-opacity="0.2" d="M65.35,54.65c1.067,1.1,1.667,2.383,1.801,3.85H61.5v-5.6		C63,53,64.283,53.583,65.35,54.65z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.checkboxes",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M47,48.5v6c0,0.134,0.05,0.25,0.15,0.35		C47.25,54.95,47.367,55,47.5,55h6c0.134,0,0.25-0.05,0.35-0.15C53.95,54.75,54,54.634,54,54.5v-6c0-0.133-0.05-0.25-0.15-0.35		c-0.1-0.1-0.216-0.15-0.35-0.15h-6c-0.133,0-0.25,0.05-0.35,0.15S47,48.367,47,48.5z M46.2,47.2c0.133-0.133,0.283-0.2,0.45-0.2		h7.7c0.2,0,0.351,0.067,0.45,0.2c0.134,0.133,0.2,0.283,0.2,0.45v3.65c0.015-0.456,0.131-0.856,0.35-1.2		c0.2-0.399,0.467-0.6,0.801-0.6H66.8c0.334,0,0.617,0.2,0.851,0.6c0.233,0.4,0.35,0.867,0.35,1.4s-0.116,1-0.35,1.4		c-0.233,0.399-0.517,0.6-0.851,0.6H56.15c-0.334,0-0.601-0.2-0.801-0.6c-0.219-0.344-0.335-0.744-0.35-1.2v3.649		c0,0.167-0.066,0.317-0.2,0.45c-0.099,0.132-0.248,0.198-0.45,0.2c0.202,0.002,0.352,0.068,0.45,0.2		c0.134,0.133,0.2,0.283,0.2,0.45v3.574c0.015-0.438,0.131-0.813,0.35-1.125c0.2-0.399,0.467-0.6,0.801-0.6H66.8		c0.334,0,0.617,0.2,0.851,0.6c0.233,0.4,0.35,0.867,0.35,1.4s-0.116,1-0.35,1.4c-0.233,0.399-0.517,0.6-0.851,0.6H56.15		c-0.334,0-0.601-0.2-0.801-0.6c-0.219-0.313-0.335-0.688-0.35-1.125v3.574c0,0.167-0.066,0.317-0.2,0.45		c-0.1,0.134-0.25,0.2-0.45,0.2h-7.7c-0.167,0-0.316-0.066-0.45-0.2c-0.133-0.133-0.2-0.283-0.2-0.45V56.65		c0-0.167,0.067-0.317,0.2-0.45c0.131-0.132,0.281-0.198,0.45-0.2c-0.168-0.002-0.319-0.068-0.45-0.2		c-0.133-0.133-0.2-0.283-0.2-0.45v-7.7C46,47.483,46.067,47.333,46.2,47.2z M53,49v5h-5v-5H53z M66.7,50.8		c-0.2-0.2-0.434-0.3-0.7-0.3h-9.05c-0.267,0-0.483,0.1-0.65,0.3C56.1,51,56,51.233,56,51.5s0.1,0.5,0.3,0.7		c0.167,0.2,0.384,0.3,0.65,0.3H66c0.267,0,0.5-0.1,0.7-0.3s0.3-0.434,0.3-0.7S66.9,51,66.7,50.8z M66.7,59.8		c-0.2-0.2-0.434-0.3-0.7-0.3h-9.05c-0.267,0-0.483,0.1-0.65,0.3C56.1,60,56,60.233,56,60.5s0.1,0.5,0.3,0.7		c0.167,0.2,0.384,0.3,0.65,0.3H66c0.267,0,0.5-0.1,0.7-0.3s0.3-0.434,0.3-0.7S66.9,60,66.7,59.8z M52.25,49.5		c-0.066,0-0.134,0.017-0.2,0.05c-0.133,0.033-0.233,0.101-0.3,0.2L50.3,52.5l-1.25-1.25c-0.1-0.1-0.217-0.15-0.35-0.15		c-0.134,0-0.25,0.051-0.351,0.15L48.3,51.3V51.9l1.8,1.8c0.067,0.066,0.167,0.116,0.301,0.149c0.1,0,0.199-0.017,0.3-0.05		c0.066-0.033,0.133-0.1,0.2-0.2l1.75-3.35c0.066-0.134,0.083-0.267,0.05-0.4c-0.066-0.133-0.15-0.233-0.25-0.3		C52.384,49.517,52.316,49.5,52.25,49.5z M53.85,57.15C53.75,57.05,53.634,57,53.5,57h-6c-0.133,0-0.25,0.05-0.35,0.15		c-0.1,0.1-0.15,0.216-0.15,0.35v6c0,0.134,0.05,0.25,0.15,0.35C47.25,63.95,47.367,64,47.5,64h6c0.134,0,0.25-0.05,0.35-0.15		C53.95,63.75,54,63.634,54,63.5v-6C54,57.366,53.95,57.25,53.85,57.15z M52.25,58.5c-0.066,0-0.134,0.017-0.2,0.05		c-0.133,0.033-0.233,0.101-0.3,0.2L50.3,61.5l-1.25-1.25c-0.1-0.1-0.217-0.15-0.35-0.15c-0.134,0-0.25,0.051-0.351,0.15L48.3,60.3		V60.9l1.8,1.8c0.067,0.066,0.167,0.116,0.301,0.149c0.1,0,0.199-0.017,0.3-0.05c0.066-0.033,0.133-0.1,0.2-0.2l1.75-3.35		c0.066-0.134,0.083-0.267,0.05-0.4c-0.066-0.133-0.15-0.233-0.25-0.3C52.384,58.517,52.316,58.5,52.25,58.5z M53,63h-5v-5h5V63z"/>	<path fill-rule="evenodd" clip-rule="evenodd" d="M47,48.5c0-0.133,0.05-0.25,0.15-0.35S47.367,48,47.5,48h6		c0.134,0,0.25,0.05,0.35,0.15C53.95,48.25,54,48.367,54,48.5v6c0,0.134-0.05,0.25-0.15,0.35C53.75,54.95,53.634,55,53.5,55h-6		c-0.133,0-0.25-0.05-0.35-0.15c-0.1-0.1-0.15-0.216-0.15-0.35V48.5z M53,63v-5h-5v5H53z M52.25,58.5c0.066,0,0.134,0.017,0.2,0.05		c0.1,0.066,0.184,0.167,0.25,0.3c0.033,0.134,0.017,0.267-0.05,0.4L50.9,62.6c-0.067,0.101-0.134,0.167-0.2,0.2		c-0.101,0.033-0.2,0.05-0.3,0.05c-0.134-0.033-0.233-0.083-0.301-0.149l-1.8-1.8V60.3l0.05-0.05c0.101-0.1,0.217-0.15,0.351-0.15		c0.133,0,0.25,0.051,0.35,0.15l1.25,1.25l1.45-2.75c0.066-0.1,0.167-0.167,0.3-0.2C52.116,58.517,52.184,58.5,52.25,58.5z		 M53.85,57.15C53.95,57.25,54,57.366,54,57.5v6c0,0.134-0.05,0.25-0.15,0.35C53.75,63.95,53.634,64,53.5,64h-6		c-0.133,0-0.25-0.05-0.35-0.15c-0.1-0.1-0.15-0.216-0.15-0.35v-6c0-0.134,0.05-0.25,0.15-0.35C47.25,57.05,47.367,57,47.5,57h6		C53.634,57,53.75,57.05,53.85,57.15z M52.25,49.5c0.066,0,0.134,0.017,0.2,0.05c0.1,0.066,0.184,0.167,0.25,0.3		c0.033,0.134,0.017,0.267-0.05,0.4L50.9,53.6c-0.067,0.101-0.134,0.167-0.2,0.2c-0.101,0.033-0.2,0.05-0.3,0.05		c-0.134-0.033-0.233-0.083-0.301-0.149l-1.8-1.8V51.3l0.05-0.05c0.101-0.1,0.217-0.15,0.351-0.15c0.133,0,0.25,0.051,0.35,0.15		l1.25,1.25l1.45-2.75c0.066-0.1,0.167-0.167,0.3-0.2C52.116,49.517,52.184,49.5,52.25,49.5z M66.7,59.8c0.2,0.2,0.3,0.434,0.3,0.7		s-0.1,0.5-0.3,0.7s-0.434,0.3-0.7,0.3h-9.05c-0.267,0-0.483-0.1-0.65-0.3C56.1,61,56,60.767,56,60.5s0.1-0.5,0.3-0.7		c0.167-0.2,0.384-0.3,0.65-0.3H66C66.267,59.5,66.5,59.6,66.7,59.8z M66.7,50.8c0.2,0.2,0.3,0.434,0.3,0.7s-0.1,0.5-0.3,0.7		s-0.434,0.3-0.7,0.3h-9.05c-0.267,0-0.483-0.1-0.65-0.3C56.1,52,56,51.767,56,51.5s0.1-0.5,0.3-0.7c0.167-0.2,0.384-0.3,0.65-0.3		H66C66.267,50.5,66.5,50.6,66.7,50.8z M53,49h-5v5h5V49z"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.text",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" d="M67.5,49.2l0.25,4.649h-0.6c-0.101-0.833-0.233-1.416-0.4-1.75		c-0.3-0.566-0.7-0.983-1.2-1.25c-0.533-0.267-1.2-0.399-2-0.399h-2.8V65.6c0,1.233,0.134,2,0.4,2.301		c0.366,0.399,0.933,0.6,1.699,0.6h0.7v0.55H55.1V68.5h0.7c0.867,0,1.467-0.25,1.8-0.75c0.233-0.3,0.351-1.017,0.351-2.15V50.45		h-2.4c-0.934,0-1.6,0.066-2,0.2c-0.5,0.166-0.934,0.517-1.3,1.05s-0.583,1.25-0.65,2.149h-0.55L51.3,49.2H67.5z"/>			<path fill-rule="evenodd" clip-rule="evenodd" fill="none" stroke="#000000" stroke-linecap="round" stroke-linejoin="round" stroke-miterlimit="3" d="		M46.35,48H48h1.7 M46.35,69.35H48V48 M48,69.35h1.7"/></g></svg>'
    },
    {
        id: "mouse-pointer.tool.btext",
        xShift: -48, yShift: -48,
        data:'<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"	 width="96px" height="96px" viewBox="0 0 96 96" enable-background="new 0 0 96 96" xml:space="preserve"><g>	<path fill-rule="evenodd" clip-rule="evenodd" d="M47.3,47.3c0.2-0.2,0.434-0.3,0.7-0.3s0.517,0.1,0.75,0.3		C48.917,47.467,49,47.7,49,48c0,0.1-0.017,0.217-0.05,0.35c0.033,0.033,0.066,0.066,0.1,0.1l3.9,4.375		c0.026-0.043,0.06-0.085,0.1-0.125c0.101-0.101,0.217-0.15,0.351-0.15c0.133,0,0.25,0.05,0.35,0.15c0.1,0.1,0.15,0.217,0.15,0.35		c0,0.134-0.051,0.25-0.15,0.351c-0.1,0.1-0.217,0.149-0.35,0.149c-0.06,0-0.118-0.008-0.176-0.024		c-0.012,0.045-0.037,0.087-0.074,0.125c-0.034,0.033-0.051,0.066-0.051,0.1c-0.1,0.066-0.216,0.1-0.35,0.1		c-0.167,0-0.283-0.05-0.35-0.149L48.3,49.1c-0.066-0.066-0.1-0.116-0.1-0.149c-0.066,0-0.134,0.017-0.2,0.05		c-0.267-0.033-0.5-0.133-0.7-0.3C47.1,48.5,47,48.267,47,48C47,47.7,47.1,47.467,47.3,47.3z M69.75,52.7		c0.1,0.1,0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149		C68.95,53.3,68.9,53.184,68.9,53.05c0-0.133,0.05-0.25,0.149-0.35c0.101-0.101,0.217-0.15,0.351-0.15		C69.533,52.55,69.65,52.6,69.75,52.7z M61.05,52.7c0.101-0.101,0.217-0.15,0.351-0.15c0.133,0,0.25,0.05,0.35,0.15		c0.1,0.1,0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149		C60.95,53.3,60.9,53.184,60.9,53.05C60.9,52.917,60.95,52.8,61.05,52.7z M65.05,52.7c0.101-0.101,0.217-0.15,0.351-0.15		c0.133,0,0.25,0.05,0.35,0.15c0.1,0.1,0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351c-0.1,0.1-0.217,0.149-0.35,0.149		c-0.134,0-0.25-0.05-0.351-0.149C64.95,53.3,64.9,53.184,64.9,53.05C64.9,52.917,64.95,52.8,65.05,52.7z M63,56.55v10.3		c0,0.801,0.083,1.317,0.25,1.551c0.233,0.267,0.616,0.399,1.15,0.399h0.5v0.4h-5.75v-0.4h0.5c0.566,0,0.966-0.166,1.199-0.5		c0.167-0.233,0.25-0.717,0.25-1.45v-10.3h-1.6c-0.667,0-1.134,0.05-1.4,0.15c-0.333,0.1-0.616,0.333-0.85,0.7		c-0.267,0.366-0.417,0.866-0.45,1.5h-0.35l0.149-3.15h11l0.15,3.15h-0.4c-0.1-0.601-0.199-1-0.3-1.2		c-0.2-0.4-0.467-0.684-0.8-0.851c-0.366-0.199-0.816-0.3-1.35-0.3H63z M70.35,56.1c0.101,0.101,0.15,0.217,0.15,0.351		c0,0.133-0.05,0.25-0.15,0.35c-0.1,0.101-0.216,0.15-0.35,0.15s-0.25-0.05-0.35-0.15c-0.101-0.1-0.15-0.217-0.15-0.35		c0-0.134,0.05-0.25,0.15-0.351c0.1-0.1,0.216-0.149,0.35-0.149S70.25,56,70.35,56.1z M70.35,60.1		c0.101,0.101,0.15,0.217,0.15,0.351c0,0.133-0.05,0.25-0.15,0.35c-0.1,0.101-0.216,0.15-0.35,0.15s-0.25-0.05-0.35-0.15		c-0.101-0.1-0.15-0.217-0.15-0.35c0-0.134,0.05-0.25,0.15-0.351c0.1-0.1,0.216-0.149,0.35-0.149S70.25,60,70.35,60.1z M70.35,64.1		c0.101,0.101,0.15,0.217,0.15,0.351c0,0.133-0.05,0.25-0.15,0.35c-0.1,0.101-0.216,0.15-0.35,0.15s-0.25-0.05-0.35-0.15		c-0.101-0.1-0.15-0.217-0.15-0.35c0-0.134,0.05-0.25,0.15-0.351c0.1-0.1,0.216-0.149,0.35-0.149S70.25,64,70.35,64.1z M61.15,72.1		c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351c0-0.133,0.05-0.25,0.149-0.35		c0.101-0.1,0.217-0.15,0.351-0.15c0.133,0,0.25,0.051,0.35,0.15s0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351		C61.4,72.05,61.283,72.1,61.15,72.1z M65.15,72.1c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351		c0-0.133,0.05-0.25,0.149-0.35c0.101-0.1,0.217-0.15,0.351-0.15c0.133,0,0.25,0.051,0.35,0.15s0.15,0.217,0.15,0.35		c0,0.134-0.051,0.25-0.15,0.351C65.4,72.05,65.283,72.1,65.15,72.1z M69.65,68.1c0.1-0.1,0.216-0.149,0.35-0.149		S70.25,68,70.35,68.1c0.101,0.101,0.15,0.217,0.15,0.351c0,0.133-0.05,0.25-0.15,0.35c-0.1,0.101-0.216,0.15-0.35,0.15		s-0.25-0.05-0.35-0.15c-0.101-0.1-0.15-0.217-0.15-0.35C69.5,68.316,69.55,68.2,69.65,68.1z M68.8,71.25		c0.101-0.1,0.217-0.15,0.351-0.15c0.133,0,0.25,0.051,0.35,0.15s0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351		c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351		C68.65,71.467,68.7,71.35,68.8,71.25z M57.05,52.7c0.101-0.101,0.217-0.15,0.351-0.15c0.133,0,0.25,0.05,0.35,0.15		c0.1,0.1,0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149		C56.95,53.3,56.9,53.184,56.9,53.05C56.9,52.917,56.95,52.8,57.05,52.7z M53.5,57.15c-0.1,0.1-0.217,0.149-0.35,0.149		c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351c0-0.133,0.05-0.25,0.149-0.35		c0.101-0.101,0.217-0.15,0.351-0.15c0.133,0,0.25,0.05,0.35,0.15c0.1,0.1,0.15,0.217,0.15,0.35C53.65,56.934,53.6,57.05,53.5,57.15		z M53.15,60.3c0.133,0,0.25,0.05,0.35,0.15c0.1,0.1,0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351		c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351		c0-0.133,0.05-0.25,0.149-0.35C52.9,60.35,53.017,60.3,53.15,60.3z M53.5,64.45c0.1,0.1,0.15,0.217,0.15,0.35		c0,0.134-0.051,0.25-0.15,0.351c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149		c-0.1-0.101-0.149-0.217-0.149-0.351c0-0.133,0.05-0.25,0.149-0.35c0.101-0.101,0.217-0.15,0.351-0.15		C53.283,64.3,53.4,64.35,53.5,64.45z M53.15,69.3c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351		c0-0.133,0.05-0.25,0.149-0.35c0.101-0.101,0.217-0.15,0.351-0.15c0.133,0,0.25,0.05,0.35,0.15c0.1,0.1,0.15,0.217,0.15,0.35		c0,0.134-0.051,0.25-0.15,0.351C53.4,69.25,53.283,69.3,53.15,69.3z M52.65,71.6c0-0.133,0.05-0.25,0.149-0.35		c0.101-0.1,0.217-0.15,0.351-0.15c0.133,0,0.25,0.051,0.35,0.15s0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351		c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149C52.7,71.85,52.65,71.733,52.65,71.6z M56.8,71.25		c0.101-0.1,0.217-0.15,0.351-0.15c0.133,0,0.25,0.051,0.35,0.15s0.15,0.217,0.15,0.35c0,0.134-0.051,0.25-0.15,0.351		c-0.1,0.1-0.217,0.149-0.35,0.149c-0.134,0-0.25-0.05-0.351-0.149c-0.1-0.101-0.149-0.217-0.149-0.351		C56.65,71.467,56.7,71.35,56.8,71.25z"/>			<path fill-rule="evenodd" clip-rule="evenodd" fill="none" stroke="#000000" stroke-linecap="round" stroke-linejoin="round" stroke-miterlimit="3" d="		M55.5,54.9h-1.15v14.5h1.15 M54.35,54.9H53.15 M53.15,69.3L54.35,69.4"/></g></svg>'
    }
];

//
MousePointerLibrary.prototype.getPointerIdByToolId = function(toolId, objDetails){
    var a = this.toolPointerMatches, i, n = a.length;
    var details = (typeof objDetails == TYPE_OBJECT) ? objDetails : null;
    var obj, aPointerId, ii;
    for(i=0; i<n; i++)
        if(a[i].toolId == toolId) {
            obj = a[i];
            if(typeof obj.pointerId == TYPE_STRING)
                return a[i].pointerId;
            else if(details != null && Array.isArray(obj.pointerId)){
                aPointerId = obj.pointerId;
                if(typeof details.buttonNumber == TYPE_NUMBER){
                    ii = details.buttonNumber;
                    if(ii<aPointerId.length)
                        return aPointerId[ii];
                }
            }
        }
    return null;
};
/**
 * @constructor
 */
function ImageModelElement(_objResourceData){
	ImageModelElement.superclass.constructor.call(this, _objResourceData);
    var me = this;
    if(me.objData.xTL > me.objData.xBR){
        var xTL = me.objData.xTL;
        me.objData.xTL = me.objData.xBR;
        me.objData.xBR = xTL;
    }
    if(me.objData.yTL > me.objData.yBR){
        var yTL = me.objData.yTL;
        me.objData.yTL = me.objData.yBR;
        me.objData.yBR = yTL;
    }
    me.objDataConst.highlightWidth = me.DEFAULT_HIGHLIGHT_WIDTH;
    //можно масштабировать рамкой
    me.objDataConst.flagScalable = true;
    //
    me.flagScrollerProvoking = true;
}
extend(ImageModelElement, ModelElement);

ImageModelElement.prototype.typePrefix = ModelResource.prototype.TYPE_IMAGE;
ImageModelElement.prototype.familyPrefix = ModelResource.prototype.TYPE_IMAGES;
ImageModelElement.prototype.className = ModelResource.prototype.CLASSID_IMAGE;

ImageModelElement.prototype.aPropretyNameMap = ImageModelElement.superclass.aPropretyNameMap.slice(0);
(function(){
	var a = ImageModelElement.prototype.aPropretyNameMap;
	a.splice(a.length, 0,
		["X", "x",  TYPE_NUMBER],
		["Y", "y",  TYPE_NUMBER],
		["File", "url", TYPE_STRING],
        ["img", "img", TYPE_OBJECT],
		["xMin", "xTL", TYPE_NUMBER],
		["yMin", "yTL", TYPE_NUMBER],
		["xMax", "xBR", TYPE_NUMBER],
		["yMax", "yBR", TYPE_NUMBER]
	);
})();

//
ImageModelElement.prototype.getX = function(){
    return this.objData.x;
};

//
ImageModelElement.prototype.getY = function(){
    return this.objData.y;
};

//
ImageModelElement.prototype.getXTL = function(){
    return this.objData.xTL;
};

//
ImageModelElement.prototype.getYTL = function(){
    return this.objData.yTL;
};

//
ImageModelElement.prototype.getXBR = function(){
    return this.objData.xBR;
};

//
ImageModelElement.prototype.getYBR = function(){
    return this.objData.yBR;
};

//override
ImageModelElement.prototype.getBounds = function() {
    var objData = this.objData;
    var xTL = objData.xTL, yTL = objData.yTL, xBR = objData.xBR, yBR = objData.yBR;
    var x = objData.x+objData.xTL;
    var y = objData.y+objData.yTL;
    return {x:x, y:y, width:Math.abs(xBR-xTL+1), height:Math.abs(yBR-yTL+1)};
};

//as implied by flagScalable
ImageModelElement.prototype.getExtremeBounds = function(){
    return {widthMin:2, heightMin:2};
};

//as implied by flagScalable
ImageModelElement.prototype.setBounds = function(objBounds){
    var me = this;
    var objData = me.objData;
    objData.x = objBounds.x;
    objData.y = objBounds.y;
    objData.xTL = 0;
    objData.yTL = 0;
    objData.xBR = objBounds.width-1;
    objData.yBR = objBounds.height-1;
};

ImageModelElement.prototype.getX = function(){
    return this.objData.x;
};

ImageModelElement.prototype.setX = function(v){
    this.objData.x = v;
};

ImageModelElement.prototype.getY = function(){
    return this.objData.y;
};

ImageModelElement.prototype.setY = function(v){
    this.objData.y = v;
};

//
ImageModelElement.prototype.getHitTestInfoForPoint = function(p0){
    var me = this;
    var flagHit = (
                p0.x>=me.objData.x+me.objData.xTL && p0.x<=me.objData.x+me.objData.xBR &&
                p0.y>=me.objData.y+me.objData.yTL && p0.y<=me.objData.y+me.objData.yBR);
    var flagInside = flagHit;
    return new HitTestInfo(me, flagHit, flagInside);
};

//
ImageModelElement.prototype.isPointWithin = function(p0){
    return this.getHitTestInfoForPoint().isHit();
};
/**
 * @constructor
 */
function PointModelElement(_objResourceData){
	PointModelElement.superclass.constructor.call(this, _objResourceData);
	var me = this;
}
extend(PointModelElement, ModelElementWithFill);

PointModelElement.prototype.typePrefix = ModelResource.prototype.TYPE_POINT;
PointModelElement.prototype.familyPrefix = ModelResource.prototype.TYPE_POINTS;
PointModelElement.prototype.className = ModelResource.prototype.CLASSID_POINT;
PointModelElement.prototype.localizedNamePrefix = "Символ ";

PointModelElement.prototype.aMethodNameForProperty =
    miscFunctions.cloneObject(PointModelElement.superclass.aMethodNameForProperty);
PointModelElement.prototype.setMethodNameForProperty(
    PointModelElement.prototype.aMethodNameForProperty, "symbolId", false, "getSymbolId"
);
PointModelElement.prototype.setMethodNameForProperty(
    PointModelElement.prototype.aMethodNameForProperty, "symbolId", true, "setSymbolId"
);
PointModelElement.prototype.setMethodNameForProperty(
    PointModelElement.prototype.aMethodNameForProperty, "checkType", false, "isCheckType"
);

PointModelElement.prototype.aPropretyNameMap = PointModelElement.superclass.aPropretyNameMap.slice(0);
(function(){
	var a = PointModelElement.prototype.aPropretyNameMap;
	a.splice(a.length, 0,
        ["X", "x",  TYPE_NUMBER],
        ["Y", "y",  TYPE_NUMBER],
		["CHSZ", "flagCheckSize",  TYPE_BOOLEAN],
		["CHTY", "flagCheckType",  TYPE_BOOLEAN],
		["Symbol", "symbolId", TYPE_STRING]
	);
})();

//
PointModelElement.prototype.getX = function(){
    return this.objData.x;
};

//in order to move by mouse
PointModelElement.prototype.setX = function(v){
    this.objData.x = v;
};

//
PointModelElement.prototype.getY = function(){
    return this.objData.y;
};

//in order to move by mouse
PointModelElement.prototype.setY = function(v){
    this.objData.y = v;
};

//
PointModelElement.prototype.isCheckSize = function(){
    return this.objData.flagCheckSize;
};

//
PointModelElement.prototype.isCheckType = function(){
    return this.objData.flagCheckType;
};

//
PointModelElement.prototype.getSymbolId = function() {
    return this.objData.symbolId;
};

//
PointModelElement.prototype.setSymbolId = function(sId) {
    this.objData.symbolId = sId;
};

//
//override
PointModelElement.prototype.getHitTestInfoForPoint = function (p0) {
    var me = this;
    var flagHit = false, flagInside = false;
    var objSize = PointModelLibrary.prototype.getSizeById(me.objData.symbolId);
    var w2 = objSize.width/ 2, h2 = objSize.height/2;
    if(MOUSE_OR_TOUCH>0){
        var rTouch = me.TOUCH_SIZE_FACTOR/ModelElement.prototype.ZOOM_RATIO;
        if(w2<16)
            w2 *= rTouch;
        if(h2<16)
            h2 *= rTouch;
    }
    var xShift = objSize.xShift, yShift = objSize.yShift;
    var objData = me.objData;
    if(objSize.isEllipse){
        flagHit = flagInside = miscFunctions.isPointWithinEllipse(
            p0.x, p0.y, objData.x+xShift, objData.y+yShift, w2, h2);
    }else{
        flagHit = flagInside = (
                p0.x>=objData.x-w2+xShift && p0.x<=objData.x+w2+xShift &&
                p0.y>=objData.y-h2+yShift && p0.y<=objData.y+h2+yShift);
    }

    return new HitTestInfo(me, flagHit, flagInside);
};

//
PointModelElement.prototype.fPositionsMatch = function(refElement, r){
    var me = this;
    if(typeof refElement[me.POINT_WITHIN_METHOD] == TYPE_FUNCTION)
        return refElement[me.POINT_WITHIN_METHOD](new Point(me.getX(), me.getY()));
    else
        return new Point(me.getX(), me.getY()).distanceSquared(new Point(refElement.getX(), refElement.getY()))<=r*r;
};

//override
PointModelElement.prototype.isMatchForElement = function(refElement, options){
    var me = this;
    if(refElement.getType() != me.getType())
        return false;
    var zoneElement =
        (typeof options != TYPE_UNDEFINED && typeof options.zoneElement != TYPE_UNDEFINED ) ?
            options.zoneElement : refElement;
    var flag = me.fPositionsMatch(zoneElement, zoneElement.getErrorZoneRadius());
    if(flag && refElement.isCheckColor())
        flag = me.getFillColor() == refElement.getFillColor();
    if(flag && refElement.isCheckType())
        flag = me.getSymbolId() == refElement.getSymbolId();
    return flag;
};
/**
 * @constructor
 */
function RectangleModelElement(_objResourceData){
	RectangleModelElement.superclass.constructor.call(this, _objResourceData);
	var me = this;
    if(me.objData.xTL > me.objData.xBR){
        var xTL = me.objData.xTL;
        me.objData.xTL = me.objData.xBR;
        me.objData.xBR = xTL;
    }
    if(me.objData.yTL > me.objData.yBR){
        var yTL = me.objData.yTL;
        me.objData.yTL = me.objData.yBR;
        me.objData.yBR = yTL;
    }
    //смещение внутреннего края границы внутрь относительно "внутреннего" прямоугольника
    me.objDataConst.padding = 2;
    //можно масштабировать рамкой
    me.objDataConst.flagScalable = true;
}
extend(RectangleModelElement, ModelElementWithBorder);

RectangleModelElement.prototype.typePrefix = ModelResource.prototype.TYPE_RECTANGLE;
RectangleModelElement.prototype.familyPrefix = ModelResource.prototype.TYPE_RECTANGLES;
RectangleModelElement.prototype.className = ModelResource.prototype.CLASSID_RECTANGLE;

RectangleModelElement.prototype.localizedNamePrefixRectangle = "Прямоугольник ";
RectangleModelElement.prototype.localizedNamePrefixEllipse = "Эллипс ";

RectangleModelElement.prototype.aPropretyNameMap = RectangleModelElement.superclass.aPropretyNameMap.slice(0);
(function(){
	var a = RectangleModelElement.prototype.aPropretyNameMap;
	a.splice(a.length, 0, 
		["subType", "subType",  TYPE_STRING],
		["XS", "xTL", TYPE_NUMBER],
		["YS", "yTL", TYPE_NUMBER],
		["XF", "xBR", TYPE_NUMBER],
		["YF", "yBR", TYPE_NUMBER]
	);
})();

//
RectangleModelElement.prototype.getSubType = function(){
    return this.objData.subType;
};

//
RectangleModelElement.prototype.getXTL = function(){
    return this.objData.xTL;
};

//
RectangleModelElement.prototype.setXTL = function(v){
    this.objData.xTL = v;
};

//
RectangleModelElement.prototype.getYTL = function(){
    return this.objData.yTL;
};

//
RectangleModelElement.prototype.setYTL = function(v){
    this.objData.yTL = v;
};

//
RectangleModelElement.prototype.getXBR = function(){
    return this.objData.xBR;
};

//
RectangleModelElement.prototype.setXBR = function(v){
    this.objData.xBR = v;
};

//
RectangleModelElement.prototype.getYBR = function(){
    return this.objData.yBR;
};

//
RectangleModelElement.prototype.setYBR = function(v){
    this.objData.yBR = v;
};

//override
RectangleModelElement.prototype.getBounds = function(){
    var objData = this.objData;
    var xTL = objData.xTL, yTL = objData.yTL, xBR = objData.xBR, yBR = objData.yBR;
    var x = (xTL<xBR) ? xTL :xBR;
    var y = (yTL<yBR) ? yTL : yBR;
    return {x:x, y:y, width:Math.abs(xBR-xTL), height:Math.abs(yBR-yTL)};
};

//as implied by flagScalable
RectangleModelElement.prototype.setBounds = function(objBounds){
    var me = this;
    var objData = me.objData;
    objData.xTL = objBounds.x;
    objData.yTL = objBounds.y;
    objData.xBR = objBounds.x+objBounds.width;
    objData.yBR = objBounds.y+objBounds.height;
};

//as implied by flagScalable
RectangleModelElement.prototype.getExtremeBounds = function(){
    return {
        widthMin:2*RectangleModelElement.prototype.DEFAULT_BORDER_WIDTH,
        heightMin:2*RectangleModelElement.prototype.DEFAULT_BORDER_WIDTH
    };
};

RectangleModelElement.prototype.getX = function(){
  return this.objData.xTL;
};

RectangleModelElement.prototype.setX = function(v){
    var me = this;
    var objData = me.objData;
    var w = objData.xBR - objData.xTL;
    objData.xTL = v;
    objData.xBR = v+w;
};

RectangleModelElement.prototype.getY = function(){
    return this.objData.yTL;
};

RectangleModelElement.prototype.setY = function(v){
    var me = this;
    var objData = me.objData;
    var h = objData.yBR - objData.yTL;
    objData.yTL = v;
    objData.yBR = v+h;
};

//
//override
RectangleModelElement.prototype.getHitTestInfoForPoint = function(p0){
    var me = this;
    var bW = this.objDataConst.borderWidth;
    var padding = this.objDataConst.padding;
    var margin = (bW>padding) ? (bW-padding) : 0;
    var flagHit = false, flagInside = false;
    switch(me.objData.subType){
        case "ellipse":
            var w = me.objData.xBR - me.objData.xTL, w2 = w/ 2;
            var h = me.objData.yBR - me.objData.yTL, h2 = h/ 2;
            var xC = (me.objData.xBR + me.objData.xTL)/2;
            var yC = (me.objData.yBR + me.objData.yTL)/2;
            flagHit = miscFunctions.isPointWithinEllipse(p0.x, p0.y, xC, yC, w2 + margin, h2 + margin);
            if(flagHit)
                flagInside = miscFunctions.isPointWithinEllipse(p0.x, p0.y, xC, yC, w2-padding, h2-padding);
            break;
        case "rectangle":
            flagHit = (p0.x>=me.objData.xTL-margin &&
                        p0.x<=me.objData.xBR+margin &&
                        p0.y>=me.objData.yTL-margin &&
                        p0.y<=me.objData.yBR+margin);
            if(flagHit)
                flagInside = (p0.x>=me.objData.xTL+padding &&
                                p0.x<=me.objData.xBR-padding &&
                                p0.y>=me.objData.yTL+padding &&
                                p0.y<=me.objData.yBR-padding);
            break;
        default:;
    }
    return new HitTestInfo(me, flagHit, flagInside);
};

//
//
RectangleModelElement.prototype.isPointWithin = function(p0){
    return this.getHitTestInfoForPoint(p0).isHit();
};

//
RectangleModelElement.prototype.fPositionsMatch = function(refElement, r) {
    var r2 = r*r;
    var me = this;
    return (new Point(me.getXTL(), me.getYTL()).distanceSquared(new Point(refElement.getXTL(), refElement.getYTL())) <= r2) &&
        (new Point(me.getXBR(), me.getYBR()).distanceSquared(new Point(refElement.getXBR(), refElement.getYBR())) <= r2);
};


//override
RectangleModelElement.prototype.isMatchForElement = function(refElement, options) {
    var me = this;
    if (refElement.getType() != me.getType() || refElement.getSubType() != me.getSubType())
        return false;
    var zoneElement =
        (typeof options != TYPE_UNDEFINED && typeof options.zoneElement != TYPE_UNDEFINED ) ?
            options.zoneElement : refElement;
    if(zoneElement.getType() != me.getType())
        return false;
    var flag = me.fPositionsMatch(zoneElement, zoneElement.getErrorZoneRadius());
    if(flag && refElement.isCheckFillColor())
        flag =
            (refElement.isEmptyFill() && me.isEmptyFill()) ||
            (!(refElement.isEmptyFill() || me.isEmptyFill()) && (me.getFillColor() == refElement.getFillColor()));
    if(flag && refElement.isCheckBorderColor())
        flag = me.getLineColor() == refElement.getLineColor();
    return flag;
};
/**
 * @constructor
 */
function PolylineModelElement(_objResourceData){
    PolylineModelElement.superclass.constructor.call(this, _objResourceData);
    var me = this;
    me.objDataConst.rollOverBorderWidth = me.ROLLOVER_BORDER_WIDTH;
    me.aPoint = [];
    var aNode = _objResourceData.aNode, node, i, n, a, aPoint = me.aPoint, j, l, sContent;
    if(Array.isArray(aNode)){
        n = aNode.length;
        for(i=0; i<n; i++){
            node = aNode[i];
            sContent =
                (typeof node.textContent  == TYPE_STRING) ?
                    node.textContent :
                    ((typeof node.innerText == TYPE_STRING) ? node.innerText : null);
            if(node.nodeName == "Points" && sContent != null){
                a = (sContent.length>0) ? sContent.split(",") : [];
                l = a.length;
                for(j=0; j<l; j+=2)
                    aPoint.push(new Point(parseFloat(a[j]), parseFloat(a[j+1])));
            }
        }
    }
    me.pressedHandlerNumber = -1;
    //is it possible to add and remove vertices and segments
    me.flagStructureEditable = false;
    //
    me.flagVerticesMovable = false;
}
extend(PolylineModelElement, ModelElementWithBorder);

PolylineModelElement.prototype.typePrefix = ModelResource.prototype.TYPE_PLO;
PolylineModelElement.prototype.familyPrefix = ModelResource.prototype.TYPE_PLOS;
PolylineModelElement.prototype.className = ModelResource.prototype.CLASSID_PLO;
PolylineModelElement.prototype.localizedNamePrefix = "Ломаная ";

PolylineModelElement.prototype.DEFAULT_BORDER_WIDTH = 3;
PolylineModelElement.prototype.ROLLOVER_BORDER_WIDTH = 10;
PolylineModelElement.prototype.HANDLER_DIAMETER = 10;
PolylineModelElement.prototype.CROSS_SIZE = 14;
PolylineModelElement.prototype.CROSS_STRIPE_WIDTH = 2;

PolylineModelElement.prototype.DEFAULT_MAXIMAL_CLOSE_DISTANCE = 10;
PolylineModelElement.prototype.MINIMAL_NONCOLLINEAR_SCATTERING = 2.5;

PolylineModelElement.prototype.aPropretyNameMap = PolylineModelElement.superclass.aPropretyNameMap.slice(0);
(function(){
    var a = PolylineModelElement.prototype.aPropretyNameMap;
    a.splice(a.length, 0,
        ["CLF", "flagCloseLine",  TYPE_BOOLEAN],
        ["X", "x",  TYPE_NUMBER],
        ["Y", "y",  TYPE_NUMBER]
    );
})();

//
PolylineModelElement.prototype.addPoint = function (p, index) {
    var me = this;
    var aPoint = me.aPoint;
    var i = (typeof index == TYPE_NUMBER) ? (index | 0) : aPoint.length;
    if(i <= aPoint.length)
        aPoint.splice(i, 0, p);
};

//
PolylineModelElement.prototype.getMinimalPointCount = function(){
    return this.objData.flagCloseLine ? 3 : 2;
};

//
PolylineModelElement.prototype.removePoint = function (index, flagTestIfCollinear) {
    var me = this;
    //cheeck if the remaining points of the closed polyline are on the same line.
    // If they are, the deletion fails
    var testCollinear = (typeof flagTestIfCollinear == TYPE_BOOLEAN) ? flagTestIfCollinear : false;
    var aPoint = me.aPoint;
    var a, n, p0, p1, p2, d;
    var nMin = me.getMinimalPointCount();
    var i = (typeof index == TYPE_NUMBER) ? (index | 0) : (aPoint.length-1);
    if(i>=0 && i<aPoint.length && aPoint.length>nMin) {
        var flag = true;
        if(testCollinear && me.isCloseLine()){
			var ii;
            n = me.getPointCount();
            //middle point
            p0 = new Point(0, 0);
            for(ii=0; ii<n; ii++) {
                if(ii == i)
                    continue;
                p1 = aPoint[ii];
                p0.offset(p1.x, p1.y);
            }
            p0.x /= (n-1);
            p0.y /= (n-1);
            a = [];
            for(ii=0; ii<n; ii++) {
                if(ii == i)
                    continue;
                a.push(aPoint[ii].subtract(p0));
                p1 = a[a.length-1];
                //make all vectors point approximately the same direction
                if (
                    (Math.abs(p1.x) > Math.abs(p1.y) && p1.x < 0) ||
                    (Math.abs(p1.y) > Math.abs(p1.x) && p1.y < 0)
                ) {
                    p1.x *=-1;
                    p1.y *= -1;
                }
            }
            n--;
            p2 = new Point(0, 0);
            for(ii=0; ii<n; ii++) {
                p1 = a[ii];
                p2.offset(p1.x, p1.y);
            }
            p2.normalize(1);
            //perpendicular
            p2 = new Point(p2.y, -p2.x);

            d = 0;
            for(ii=0; ii<n; ii++){
                p1 = a[ii];
                d += Math.abs(p1.x*p2.x+p1.y*p2.y);
            }
            d /= n;

            flag = (d>me.MINIMAL_NONCOLLINEAR_SCATTERING);
        }
        a = flag ? aPoint.splice(i, 1) : null;
        if(a!=null && i==0 && a.length>0 && aPoint.length>0){
            var dx = aPoint[0].x-a[0].x;
            var dy = aPoint[0].y-a[0].y;
            n = me.getPointCount();
            for(i=0; i<n; i++){
                aPoint[i].x -= dx;
                aPoint[i].y -= dy;
            }
            me.setX(me.getX()+dx);
            me.setY(me.getY()+dy);
        }
    }else
        a = null;

    return (Array.isArray(a) && a.length>0) ? a[0] : null;
};

//
PolylineModelElement.prototype.removeSegment = function(index){
    var me = this;
    var aPoint = me.aPoint;
    if(me.isCloseLine() && index>=0 && index<aPoint.length){
        if(index<(aPoint.length-1)) {
            var a = aPoint.splice(0, index + 1), i;
            for (i = 0; i <= index; i++)
                aPoint.push(a[i]);
            var p0 = new Point(aPoint[0].x, aPoint[0].y);
            for(i = 0; i < aPoint.length; i++)
                aPoint[i].offset(-p0.x, -p0.y);
            me.objData.x += p0.x;
            me.objData.y += p0.y;
        }
        me.objData.flagCloseLine = false;
    }
};

//
PolylineModelElement.prototype.closeLine = function(flagSnapTailToHead){
    var me = this;
    if(me.isCloseLine())
        return;
    var flagSnap = (typeof flagSnapTailToHead == TYPE_BOOLEAN) ? flagSnapTailToHead : false;
    var n = me.getPointCount();
    var canClose = (flagSnap && n>=4) || (!flagSnap && n>=3);
    if(canClose) {
        if(flagSnap)
            me.removePoint(n-1);
        me.objData.flagCloseLine = true;

    }
};

//
PolylineModelElement.prototype.isCloseLine = function(){
    return this.objData.flagCloseLine;
};

//
PolylineModelElement.prototype.getX = function(){
    return this.objData.x;
};

//in order to move
PolylineModelElement.prototype.setX = function(v){
    this.objData.x = v;
};


//
PolylineModelElement.prototype.getY = function(){
    return this.objData.y;
};

//in order to move
PolylineModelElement.prototype.setY = function(v){
    this.objData.y = v;
};

//
PolylineModelElement.prototype.getPoints = function(){
    return this.aPoint;
};

//
PolylineModelElement.prototype.getPointCount = function(){
    return this.aPoint.length;
};

//
PolylineModelElement.prototype.isVerticesMovable = function(){
    return this.flagVerticesMovable;
};

//
PolylineModelElement.prototype.setVerticesMovable = function(flag){
    this.flagVerticesMovable = flag;
};

//
PolylineModelElement.prototype.getPressedHandlerNo = function(){
    return this.pressedHandlerNumber;
};

//
PolylineModelElement.prototype.setPressedHandlerNo = function(no){
    this.pressedHandlerNumber = no;
};

//override
PolylineModelElement.prototype.isMovableByMouse = function(){
    var flag = PolylineModelElement.superclass.isMovableByMouse.call(this);
    var hitDetails = this.hitDetails;
    return flag && (hitDetails == null || !this.isVerticesMovable() || hitDetails.handlerNumber == -1);
};

//
PolylineModelElement.prototype.isCloseEnds = function(){
    var me = this;
    if(!( me.isCloseLine() || me.getPointCount()<4)) {
        var aPoint = me.getPoints();
        var pHead = aPoint[0];
        var pTail = aPoint[me.getPointCount() - 1];
        var d = me.DEFAULT_MAXIMAL_CLOSE_DISTANCE, d2 = d * d;
        return (pHead.distanceSquared(pTail) < d2);
    }
    return false;
};

//
//override
PolylineModelElement.prototype.getHitTestInfoForPoint = function(p0) {
    var me = this;
    var bW;
    var aPoint = me.aPoint;
    var x = me.getX(), y = me.getY();
    var pA = p0.subtract(new Point(x, y));

    var handlerRadius;
    var rTouch = me.TOUCH_SIZE_FACTOR/ModelElement.prototype.ZOOM_RATIO;
    if(MOUSE_OR_TOUCH>0 && !me.isCloseLine())
        bW = me.objDataConst.rollOverBorderWidth * rTouch;
    else
        bW = me.isStructureEditable() ? me.objDataConst.rollOverBorderWidth : me.objDataConst.borderWidth;

    if(MOUSE_OR_TOUCH>0)
        handlerRadius = me.HANDLER_DIAMETER/2 * rTouch;
    else
        handlerRadius = me.HANDLER_DIAMETER/2;

    var i, n = aPoint.length;
    for(i=0; i<n; i++)
        if(miscFunctions.isPointWithinEllipse(p0.x, p0.y, x+aPoint[i].x, y+aPoint[i].y, handlerRadius, handlerRadius))
            break;
    var handlerNumber = (i<n) ? i : -1;

    var segmentNumber = -1;
    var pOnSegment = null;

    var flagHit = (handlerNumber != -1);
    var flagInside = false;

    if(!flagHit){
        segmentNumber = miscFunctions.getPolygonBorderSegmentNumberForPoint(pA, aPoint, bW);
        if(!me.isCloseLine() && segmentNumber == (aPoint.length-1))
            segmentNumber = -1;
        flagHit = (segmentNumber != -1);
        if(segmentNumber != -1){
            //position of the segment-snapped point (projection of p0 on the segment)
            var pStart = aPoint[segmentNumber];
            var pEnd = aPoint[(segmentNumber == (aPoint.length-1)) ? 0 : (segmentNumber+1)];
            var p = p0.subtract(new Point(x, y)).subtract(pStart);
            var vN = pEnd.subtract(pStart);
            var rV = vN.length();
            vN.normalize(1);
            var sProd = p.x*vN.x+ p.y*vN.y;
            if(sProd<handlerRadius || sProd>(rV-handlerRadius))
                segmentNumber = -1;
            else
                pOnSegment = new Point(x+pStart.x+vN.x*sProd, y+pStart.y+vN.y*sProd);
        }
    }
    //? inside. Ray tracing
    if(!flagHit && me.isCloseLine())
        flagHit = flagInside = miscFunctions.isPointWithinPolygon(pA, aPoint);

    return new HitTestInfo(
        me, flagHit, flagInside,
        {segmentNumber:segmentNumber, handlerNumber:handlerNumber, pointOnSegment:pOnSegment}
    );
};

//
PolylineModelElement.prototype.isPointWithin = function(p0){
    var me = this;
    return miscFunctions.isPointWithinPolygon(p0.subtract(new Point(me.getX(), me.getY())), me.aPoint);
};

//
PolylineModelElement.prototype.fPositionsMatch = function(refElement, radius, checkClosed){
    var me = this;
    var flagClosed = me.isCloseLine();
    if(checkClosed && refElement.isCloseLine() != flagClosed)
        return false;
    var pStart = new Point(me.getX(), me.getY());
    var pStartRef = new Point(refElement.getX(), refElement.getY());
    var aP = me.aPoint, aPRef = refElement.getPoints();
    var i, j, n = aP.length, l = aPRef.length;
    //r2 – squared radius to avoid sqrt calculations
    var r2 = radius*radius;
    var aSegment = [], aSegmentRef = [];
    //
    function fStoreSegments(nSeg, aP, aSegment){
        var n = aP.length;
        var i, dirVector, objSegment, segLength;
        for(i=0; i<nSeg; i++){
            dirVector = aP[(i+1)%n].subtract(aP[i]);
            segLength = dirVector.length();
            if(segLength != 0)
                dirVector.multiply(1/segLength);
            objSegment = {dirVector:dirVector, segLength:segLength};
            aSegment.push(objSegment);
        }
    }
    //
    fStoreSegments(n - (flagClosed ? 0 : 1), aP, aSegment);
    fStoreSegments(l - (flagClosed ? 0 : 1), aPRef, aSegmentRef);
    //
    var aNot = [];
    var aNotRef = [];
    //
    //check if all of the me's vertices are within the "radius" from segments of refElement
    for(i=0; i<n; i++){
        p = aP[i].add(pStart);
        for(j=0; j<l; j++)
            if(p.distanceSquared(aPRef[j].add(pStartRef))<=r2)
                break;
        //for i-th point there was no close reference point; check it segment-wise
        if(j==l)
            aNot.push(i)
    }
    //conversely for the refElement's vertices
    for(j=0; j<l; j++){
        pRef = aPRef[j].add(pStartRef);
        for(i=0; i<n; i++)
            if(pRef.distanceSquared(aP[i].add(pStart))<=r2)
                break;
        //for i-th point there was no close reference point; check it segment-wise
        if(i==n)
            aNotRef.push(j)
    }
    //
    //check if all of aNot are within the refElement segments' radius-stripe
    function fCheckWithinStripe(r2, aNot, aP, pStart, aPRef, pStartRef, aSegmentRef){
        var i, j, n = aNot.length, p, objSegment, pRef, prod, vDir, v;
        var nSeg = aSegmentRef.length;
        for(i=0; i<n; i++){
            p = aP[aNot[i]].add(pStart);
            for(j=0; j<nSeg; j++) {
                //reference segment: vector, length and starting point
                objSegment = aSegmentRef[j];
                pRef = aPRef[j].add(pStartRef);
                //
                v = p.subtract(pRef);
                prod = v.scalarProduct(objSegment.dirVector);
                if (prod < 0 || prod > objSegment.segLength) {
                    //p is not within j-th segment
                    continue;
                }
                vDir = objSegment.dirVector.clone();
                vDir.multiply(prod);
                v = v.subtract(vDir);
                if(v.lengthSquared()<=r2) {
                    //p is within radius-stripe
                    break;
                }
            }
            if(j == nSeg) {
                //p is outside any radius-stripe of refElement
                return false;
            }
        }
        return true;
    }
    //
    if(
        !(
        fCheckWithinStripe(r2, aNot, aP, pStart, aPRef, pStartRef, aSegmentRef) &&
        fCheckWithinStripe(r2, aNotRef, aPRef, pStartRef, aP, pStart, aSegment)
        )
    )
        return false;

    //some intervals of the segments may be outside radius-stripes
    var nSeg = n - (flagClosed ? 0 : 1);
    var nSegRef = l - (flagClosed ? 0 : 1);
    for(i=0; i<nSeg; i++){
        var p = aP[i].add(pStart);
        var xP = p.getX(), yP = p.getY();
        var objSegment = aSegment[i];
        var l0 = objSegment.segLength;
        var xD = objSegment.dirVector.getX(), yD = objSegment.dirVector.getY();
        var aIntervalMin = [];
        var aIntervalMax = [];
        for(j=0; j<nSegRef; j++){
            var pRef = aPRef[j].add(pStartRef);
            var xPRef = pRef.getX(), yPRef = pRef.getY();
            var objSegmentRef = aSegmentRef[j];
            var xDRef = objSegmentRef.dirVector.getX(), yDRef = objSegmentRef.dirVector.getY();
            //
            var dXP = xP-xPRef, dYP = yP-yPRef;
            var vProd1 = xD*yDRef-yD*xDRef;
            var vProd2 = dXP*yDRef-dYP*xDRef;
            //
            if(Math.abs(vProd1)>1E-10){
                var t1, t2;
                if(vProd1>0) {
                    t1 = (-radius - vProd2) / (l0 * vProd1);
                    t2 = (radius - vProd2) / (l0 * vProd1);
                }else{
                    t1 = (radius - vProd2) / (l0 * vProd1);
                    t2 = (-radius - vProd2) / (l0 * vProd1);
                }
                if(t1<0)
                    t1 = 0;
                else if(t1>1)
                    t1 = 1;
                if(t2<0)
                    t2 = 0;
                else if(t2>1)
                    t2 = 1;
                //
                if(t1 == 0 && t2 == 1)
                    break;
                //interval [t1, t2] is where the current segment is within the radius-stripe of the reference segment
                aIntervalMin.push(t1);
                aIntervalMax.push(t2);
            }else {
                //current segment is parallel to the reference segment.
                // Since vertices are abovechecked to be within radius-stripe, then the whole segment is within
                break;
            }
        }
        //now calculate the overlapping of all the saved intervals
        if(j == nSegRef){
            var ii, jj, min1, max1, min2, max2, flag;
            for(ii=0; ii<aIntervalMin.length-1; ii++){
                min1 = aIntervalMin[ii];
                max1 = aIntervalMax[ii];
                for(jj=ii+1; jj<aIntervalMin.length; jj++){
                    min2 = aIntervalMin[jj];
                    max2 = aIntervalMax[jj];
                    flag = true;
                    if(min1>=min2 && max1<=max2) {
                        //****|<--->|****
                        //**|<------->|**
                        aIntervalMin[ii] = min2;
                        aIntervalMax[ii] = max2;
                    }else if(min1<=min2 && max1>=max2){
                        //****|<--->|****
                        //*****|<->|*****
                        //do not remove this clause
                    }else if(max1>=min2 && max1<=max2){
                        //****|<--->|****
                        //******|<--->|**
                        aIntervalMax[ii] = max2;
                    }else if(min1>=min2 && min1<=max2){
                        //****|<--->|****
                        //**|<--->|******
                        aIntervalMin[ii] = min2;
                    }else
                        flag = false;

                    if(flag){
                        aIntervalMin.splice(jj);
                        aIntervalMax.splice(jj--);
                    }
                }
            }
            if(aIntervalMin.length != 1 || aIntervalMin[0] != 0 || aIntervalMax[0] != 1) {
                //more than one interval remains after overlapping or the resulting interval is not [0, 1]
                return false;
            }
        }
    }

    return true;
};

//override
PolylineModelElement.prototype.isMatchForElement = function(refElement, options){
    var me = this;
    if(refElement.getType() != me.getType())
        return false;
    var flag = me.fPositionsMatch(refElement, refElement.getErrorZoneRadius(), true);
    if(flag && (refElement.isCheckFillColor() || refElement.isCheckColor()))
        flag =
            (refElement.isEmptyFill() && me.isEmptyFill()) ||
            (!(refElement.isEmptyFill() || me.isEmptyFill()) && (me.getFillColor() == refElement.getFillColor()));
    if(flag && (refElement.isCheckBorderColor() || refElement.isCheckColor()))
        flag = me.getLineColor() == refElement.getLineColor();
    return flag;
};

//override
PolylineModelElement.prototype.isForbiddenPropertyCheck = function(checkPropertyObj){
    if(
        (checkPropertyObj.name == "checkColor" && checkPropertyObj.property == "fillColor" &&
        checkPropertyObj.permission == "colorModifiable")
        ||
        (checkPropertyObj.name == "checkLineColor" && checkPropertyObj.property == "lineColor" &&
        checkPropertyObj.permission == "colorModifiable")
    )
        return !this.isCloseLine();
    else if(
        checkPropertyObj.name == "checkColor" && checkPropertyObj.property == "lineColor" &&
        checkPropertyObj.permission == "colorModifiable"
    )
        return this.isCloseLine();
    else
        return false;
};
/**
 * @constructor
 */
function TextModelElement(_objResourceData){
    TextModelElement.superclass.constructor.call(this, _objResourceData);
    var me = this;
    //
    me.flagShowIfVerified = true;
    me.flagVerifyOwnState = true;
    //
    me.objDataConst.borderWidth = me.DEFAULT_BORDER_WIDTH;
    me.objDataConst.highlightWidth = me.DEFAULT_HIGHLIGHT_WIDTH;
    //
    me.prevDrawParameters = null;
    me.objSplitParameters = null;
    //
    me.flagEditingMode = false;
    //
    me.flagFillColored = true;
    me.flagLineColored = true;
    //
    me.correctText = me.getText();
    //
    me.correctFontSize = me.getFontSize();
    //
    me.correctFontFace = me.getFontFace();
    //
    me.correctFontColor = me.getFontColor();
    //
    if(me.isVerifiable()) {
        me.setText("");
        if(me.isCheckFont())
            me.setFontFace(me.DEFAULT_FONT_FACE);
        if(me.isCheckColor())
            me.setFontColor(me.DEFAULT_FONT_COLOR);
        if(me.isCheckSize())
            me.setFontSize(me.DEFAULT_FONT_SIZE);
        me.setFontAlpha(100);
    }
}
extend(TextModelElement, ModelElement);

TextModelElement.prototype.TOUCH_SIZE_FACTOR = 5;

TextModelElement.prototype.typePrefix = ModelResource.prototype.TYPE_TEXT;
TextModelElement.prototype.familyPrefix = ModelResource.prototype.TYPE_TEXTS;
TextModelElement.prototype.className = ModelResource.prototype.CLASSID_TEXT;
TextModelElement.prototype.localizedNamePrefix = "Текст ";

//regular expression for new line symbols
TextModelElement.prototype.NEW_LINE_REGULAR_EXPRESSION = /(\r|\n|<br( *)\/>)+/g;
TextModelElement.prototype.NEW_LINE_BEGINS_ENDS_REGULAR_EXPRESSION = /(^((\r|\n|<br( *)\/>)+))|(((\r|\n|<br( *)\/>)+)$)/g;

//measuring canvas is for calculating text size when adjusting height
TextModelElement.prototype.measuringCanvas = document.createElement("CANVAS");

//no-word-wrap tolerance at 100% scale
TextModelElement.prototype.NO_WORD_WRAP_TOLERANCE = 2;

TextModelElement.prototype.DEFAULT_BORDER_WIDTH = 1;
TextModelElement.prototype.DEFAULT_HIGHLIGHT_WIDTH = 2;

TextModelElement.prototype.DEFAULT_FONT_FACE = "Arial";
TextModelElement.prototype.DEFAULT_FONT_SIZE = 20;
TextModelElement.prototype.DEFAULT_FONT_COLOR = 0x000000;
TextModelElement.prototype.PADDING_LEFT = 2;
TextModelElement.prototype.PADDING_RIGHT = 2;
TextModelElement.prototype.FRAME_CORNER_SIZE = 8;

TextModelElement.prototype.aMethodNameForProperty =
    miscFunctions.cloneObject(TextModelElement.superclass.aMethodNameForProperty);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillColor", false, "getFontColor"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillColor", true, "setFontColor"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillAlpha", false, "getFontAlpha"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillAlpha", true, "setFontAlpha"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "lineColor", false, "getBorderColor"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "lineColor", true, "setBorderColor"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "lineAlpha", false, "getBorderAlpha"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "lineAlpha", true, "setBorderAlpha"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillColorCtrl", false, "getBackgroundColor"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillColorCtrl", true, "setBackgroundColor"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillAlphaCtrl", false, "getBackgroundAlpha"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fillAlphaCtrl", true, "setBackgroundAlpha"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fontSize", false, "getFontSize"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fontSize", true, "setFontSize"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fontFace", false, "getFontFace"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "fontFace", true, "setFontFace"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "horizontalAlign", false, "getHorizontalAlign"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "horizontalAlign", true, "setHorizontalAlign"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "editingMode", false, "isEditingMode"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "editingMode", true, "setEditingMode"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "lineCount", false, "getLineCount"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "characterBounds", false, "getCharacterBounds"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "textInputWidth", false, "getWidth"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "textInputWidth", true, "setWidth"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "textInputHeight", false, "getHeight"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "textInputHeight", true, "setHeight"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "text", false, "getText"
);
TextModelElement.prototype.setMethodNameForProperty(
    TextModelElement.prototype.aMethodNameForProperty, "text", true, "setText"
);

TextModelElement.prototype.aPropretyNameMap = TextModelElement.superclass.aPropretyNameMap.slice(0);
(function(){
    var a = TextModelElement.prototype.aPropretyNameMap;
    a.splice(a.length, 0,
        ["X", "x",  TYPE_NUMBER],
        ["Y", "y",  TYPE_NUMBER],
        ["Height", "height", TYPE_NUMBER],
        ["Width", "width", TYPE_NUMBER],
        ["CHCL", "flagCheckColor",  TYPE_BOOLEAN],
        ["CHSZ", "flagCheckSize",  TYPE_BOOLEAN],
        ["CHCS", "flagCheckCase",  TYPE_BOOLEAN],
        ["CHFC", "flagCheckFont", TYPE_BOOLEAN],
        ["CHCT", "flagCheckText", TYPE_BOOLEAN],
        ["BorderColor", "borderColor", TYPE_INTEGER],
        ["BorderAlpha", "borderAlpha", TYPE_INTEGER],
        ["vAlign", "verticalAlign", TYPE_STRING],
        ["hAlign", "horizontalAlign", TYPE_STRING],
        ["BackgroundAlpha", "backgroundAlpha", TYPE_INTEGER],
        ["BackgroundColor", "backgroundColor", TYPE_INTEGER],
        ["fontAlpha", "fontAlpha", TYPE_INTEGER],
        ["fontColor", "fontColor", TYPE_INTEGER],
        ["fontSize", "fontSize", TYPE_INTEGER],
        ["fontFace", "fontFace", TYPE_STRING],
        ["text", "text", TYPE_STRING]
    );
})();

//
TextModelElement.prototype.getX = function(){
    return this.objData.x;
};

//
TextModelElement.prototype.setX = function(v){
    this.objData.x = v;
};

//
TextModelElement.prototype.getY = function(){
    return this.objData.y;
};

//
TextModelElement.prototype.setY = function(v){
    this.objData.y = v;
};

//override
TextModelElement.prototype.canBeSelected = function(){
    if(TextModelElement.superclass.canBeSelected.call(this))
       return true;
    return this.isVerifiable();
};

//
TextModelElement.prototype.isEditingMode = function(){
    return this.flagEditingMode;
};

//
TextModelElement.prototype.setEditingMode = function(flag){
    this.flagEditingMode = flag;
};

//
TextModelElement.prototype.getLineCount = function(){
    return this.getTextSplitParameters().aText.length;
};

//
TextModelElement.prototype.getHeight = function(){
    //text height depends on the text itself in MapKit implementation. Stored height is ignored
    return this.getTextSplitParameters().height;
};

//
TextModelElement.prototype.setHeight = function(v){
    this.objData.height = v;
};

//
TextModelElement.prototype.getWidth = function(){
    return this.objData.width;
};

//
TextModelElement.prototype.setWidth = function(v){
    var me = this;
    me.objData.width = v;
    //recalculate height so that there is enough room for the text
    var objSplit = me.getTextSplitParameters();
    me.objData.height = objSplit.height;
};

TextModelElement.prototype.isInitiallyTurnedOn = function(){
    return this.objData.flagInitiallyTurnedOn || this.objData.flagVerifiable;
};


//override
TextModelElement.prototype.isColorModifiable = function(){
    return this.isVerifiable() || TextModelElement.superclass.isColorModifiable.call(this);
};

//
TextModelElement.prototype.isCheckColor = function(){
    return this.objData.flagCheckColor;
};

//
TextModelElement.prototype.isCheckSize = function(){
    return this.objData.flagCheckSize;
};

//
TextModelElement.prototype.isCheckCase = function(){
    return this.objData.flagCheckCase;
};
//
TextModelElement.prototype.isCheckFont = function(){
    return this.objData.flagCheckFont;
};
//
TextModelElement.prototype.isCheckText = function(){
    return this.objData.flagCheckText;
};

//
//kind of override
TextModelElement.prototype.isTextModifiable = function(){
    return this.isVerifiable() || this.isShapeModifiable();
};

//
TextModelElement.prototype.isFontSizeModifiable = function(){
    var me = this;
    if(me.isVerifiable())
        return me.isCheckSize();
    else
        return me.isShapeModifiable();
};

//
TextModelElement.prototype.isFontFaceModifiable = function(){
    var me = this;
    if(me.isVerifiable())
        return me.isCheckFont();
    else
        return me.isShapeModifiable();
};

//
TextModelElement.prototype.isHorizontalAlignModifiable = function(){
    var me = this;
    if(me.isVerifiable())
        return me.isCheckFont();
    else
        return me.isShapeModifiable();
};

//
TextModelElement.prototype.getBorderColor = function(){
    var v = this.objData.borderColor;
    return isNaN(v) ? 0xFFFFFF : v;
};

//
TextModelElement.prototype.setBorderColor = function(v){
    this.objData.borderColor = v;
};

//
TextModelElement.prototype.getBorderAlpha = function(){
    var v = this.objData.borderAlpha;
    return isNaN(v) ? 0 : v;
};

//
TextModelElement.prototype.setBorderAlpha = function(v){
    this.objData.borderAlpha = v;
};

//
TextModelElement.prototype.getVerticalAlign = function(){
    return this.objData.verticalAlign;
};

//
TextModelElement.prototype.getHorizontalAlign = function(){
    return this.objData.horizontalAlign;
};

TextModelElement.prototype.setHorizontalAlign = function(sAlign){
    this.objData.horizontalAlign = sAlign;
};

//
TextModelElement.prototype.getBackgroundAlpha = function(){
    return this.objData.backgroundAlpha;
};

//
TextModelElement.prototype.setBackgroundAlpha = function(v){
    this.objData.backgroundAlpha = v;
};

//
TextModelElement.prototype.getBackgroundColor = function(){
    return this.objData.backgroundColor;
};

//
TextModelElement.prototype.setBackgroundColor = function(v){
    this.objData.backgroundColor = v;
};

//
TextModelElement.prototype.getFontAlpha = function(){
    return this.objData.fontAlpha;
};

//
TextModelElement.prototype.setFontAlpha = function(v){
    this.objData.fontAlpha = v;
};

//
TextModelElement.prototype.getFontColor = function(){
    return this.objData.fontColor;
};

//
TextModelElement.prototype.setFontColor = function(v){
    this.objData.fontColor = v;
};

//
TextModelElement.prototype.getFontSize = function(){
    return this.objData.fontSize;
};
TextModelElement.prototype.setFontSize = function(v){
    this.objData.fontSize = parseInt(v);
};

//
TextModelElement.prototype.getFontFace = function(){
    return this.objData.fontFace;
};
TextModelElement.prototype.setFontFace = function(sFontFace){
    this.objData.fontFace = sFontFace;
};

//
TextModelElement.prototype.getText = function(){
    return this.objData.text;
};

//
TextModelElement.prototype.setText = function(s){
    this.objData.text = s;
};

//
TextModelElement.prototype.getCorrectText = function(){
    return this.correctText;
};

//
TextModelElement.prototype.getCorrectFontSize = function(){
    return this.correctFontSize;
};

//
TextModelElement.prototype.getCorrectFontFace = function(){
    return this.correctFontFace;
};

//
TextModelElement.prototype.getCorrectFontColor = function(){
    return this.correctFontColor;
};

//
TextModelElement.prototype.getBorderWidth = function(){
    return this.objDataConst.borderWidth;
};

//
TextModelElement.prototype.splitLineForContextAndWidth = function(s, ctx, w0){
    var aSplit = [];
    var i = 0x7FFFFFFF, s1 = s, s2 = null;
    var w = ctx.measureText(s).width;
    while(w>w0){
        i = s.lastIndexOf(" ", i-1);
        if(i != -1){
            s1 = s.slice(0, i);
            s2 = s.slice(i+1);
        }else
            break;
        w = ctx.measureText(s1).width;
    }
    i = s.length;
    if(i>1) {
        while (w > w0) {
            i--;
            s1 = s.slice(0, i);
            s2 = (s.charAt(i)== ' ') ? s.slice(i+1) : s.slice(i);
            w = ctx.measureText(s1).width;
            if (s1.length == 1)
                break;
        }
        aSplit.push(s1);
        if (s2 != null)
            aSplit = aSplit.concat(TextFunctions.prototype.splitLineForContextAndWidth(s2, ctx, w0));
    }else if(i>0)
        aSplit.push(s);
    return aSplit;
};

//
TextModelElement.prototype.getTextSplitParameters = function(scaleFactor){
    var me = this;
    var objData = me.objData;
    var rSize = (typeof scaleFactor == TYPE_NUMBER) ? scaleFactor : 1.0;
    var prev = me.prevDrawParameters;
    var flag =
        (prev==null) ||
        (
        objData.text != prev.text ||
        objData.fontFace != prev.fontFace || objData.fontSize != prev.fontSize ||
        objData.width != prev.width || objData.horizontalAlign != prev.horizontalAlign ||
        rSize != prev.scaleFactor);

    if(flag)
        me.objSplitParameters = me.fGetSplitParametersForCurrentWidth(rSize);
    return me.objSplitParameters;
};

//
TextModelElement.prototype.getCharacterBounds = function(scaleFactor){
    var me = this;
    var splitParameters = me.getTextSplitParameters(scaleFactor);
    //
    var ctxTO = me.measuringCanvas.getContext("2d");
    var prevDrawParams = me.prevDrawParameters;
    var fontFace = prevDrawParams.fontFace;
    var fontSize = prevDrawParams.fontSize*scaleFactor;
    var a = fontFace.split("_");
    var i = a.indexOf("italic");
    var flagItalic = (i != -1);
    if (flagItalic)
        a.splice(i, 1);
    i = a.indexOf("bold");
    var flagBold = (i != -1);
    if (flagBold)
        a.splice(i, 1);
    var sFaceName = (a.length > 0) ? a[0] : me.DEFAULT_FONT_FACE;
    ctxTO.font = (flagItalic ? "italic" : "") + " " + (flagBold ? "bold" : "") + " " + fontSize + "px " + sFaceName;
    //
    var aText = splitParameters.aText, aC;
    var l = aText.length, s, j, n, sTmp;
    var wPrev, wCurr, yTop = 0, yBottom, w, jStartLine, flag;
    var aBounds = [], objBounds;
    for(i=0; i<l; i++){
        s = aText[i];
        aC = s.split("");
        n = aC.length;
        wPrev = 0;
        sTmp = "";
        yBottom = yTop+splitParameters.lineHeight;
        jStartLine = aBounds.length;
        for(j=0; j<n; j++){
            sTmp = sTmp.concat(aC[j]);
            wCurr = ctxTO.measureText(sTmp).width;
            objBounds = {line:i, left:wPrev, right:wCurr, width:wCurr-wPrev, top:yTop, bottom:yBottom};
            aBounds.push(objBounds);
            wPrev = wCurr;
        }
        if(n>0) {
            flag = true;
            switch (me.getHorizontalAlign()) {
                case "center":
                    w = (me.getWidth()*scaleFactor-objBounds.right)/2;
                    break;
                case "right":
                    w = me.getWidth()*scaleFactor-objBounds.right;
                    break;
                default:
                    flag = false;
            }
            if(flag)
                for(j=0; j<n; j++){
                    objBounds = aBounds[j+jStartLine];
                    objBounds.left += w;
                    objBounds.right += w;
                }
        }
        yTop = yBottom;
    }
    return aBounds;
};

//
TextModelElement.prototype.fGetSplitParametersForCurrentWidth = function(scaleFactor){
    var me = this;
    var objData = me.objData;
    var rSize = (typeof scaleFactor == TYPE_NUMBER) ? scaleFactor : 1.0;

    if(me.prevDrawParameters == null)
        me.prevDrawParameters = {};

    var prevDrawParams = me.prevDrawParameters;
    prevDrawParams.text = objData.text;
    prevDrawParams.fontFace = objData.fontFace;
    prevDrawParams.fontSize = objData.fontSize;
    prevDrawParams.width = objData.width;
    prevDrawParams.horizontalAlign = objData.horizontalAlign;
    prevDrawParams.scaleFactor = rSize;

    var sText = objData.text;
    var fontFace = objData.fontFace;
    var fontSize = objData.fontSize*rSize;

    var ctxTO = me.measuringCanvas.getContext("2d");
    //text itself
    //font face, style and weight
    var a = fontFace.split("_");
    var i = a.indexOf("italic");
    var flagItalic = (i != -1);
    if (flagItalic)
        a.splice(i, 1);
    i = a.indexOf("bold");
    var flagBold = (i != -1);
    if (flagBold)
        a.splice(i, 1);
    var sFaceName = (a.length > 0) ? a[0] : me.DEFAULT_FONT_FACE;

    //wordwrap decisions are made for 100% scale otherwise undesirable word-wraps may happen
    ctxTO.font = (flagItalic ? "italic" : "") + " " + (flagBold ? "bold" : "") + " " + objData.fontSize + "px " + sFaceName;
    //
    var sBR = "<br />";
    var aText = sText.split(sBR);
    var wText;
    var wField = objData.width;
    var dHeightLine = TextFunctions.prototype.getLineHeightByFontSize(fontSize);

    var s;
    var paddingLR = (me.PADDING_LEFT + me.PADDING_RIGHT);
    //is width enough?
    var aSplit, w0 = wField-paddingLR;
    var aSplitText = [];
    var aSplitWidth = [];

    var flagReduceSpaces = (MOUSE_OR_TOUCH == 0) || !me.isVerifiable();

    for (i = 0; i < aText.length; i++) {
        s = aText[i];
        wText = ctxTO.measureText(s).width;
        if(wText>w0+me.NO_WORD_WRAP_TOLERANCE){
            aSplit = TextFunctions.prototype.splitLineForContextAndWidth(s, ctxTO, w0, w0, flagReduceSpaces);
            aText = aText.slice(0, i).concat(aSplit).concat(aText.slice(i+1));
            s = aText[i];
            wText = ctxTO.measureText(s).width;
        }
        aSplitText.push(s);
        aSplitWidth.push(wText*rSize);
    }

    var linePadding = TextFunctions.prototype.getVerticalPaddingByFontSize(fontSize);

    return {
        aText:aSplitText,
        aWidth:aSplitWidth,
        lineHeight:dHeightLine,
        linePadding:linePadding,
        height:aText.length*dHeightLine+2*linePadding,
        face:sFaceName,
        bold:flagBold,
        italic:flagItalic
    };
};

//override
TextModelElement.prototype.isBlinkingFrameWhenSelected = function(){
    return !this.isEditingMode();
};

//override
TextModelElement.prototype.isMovableByMouse = function(){
    var flag = TextModelElement.superclass.isMovableByMouse.call(this);
    var hitDetails = this.hitDetails;
    return flag && !(typeof hitDetails.hitCorner == TYPE_BOOLEAN && hitDetails.hitCorner == true);
};

//
//override
TextModelElement.prototype.getHitTestInfoForPoint = function(p0){
    var me = this;
    var flagHit, flagInside, flagHitCorner;
    var width = me.getWidth();
    var height = me.getHeight();
    flagHit =
        p0.x>=me.objData.x && p0.x<=me.objData.x+width &&
        p0.y>=me.objData.y && p0.y<=me.objData.y+height;
    if(flagHit) {
        var cornerSize = me.FRAME_CORNER_SIZE;
        var rTouch = me.TOUCH_SIZE_FACTOR/ModelElement.prototype.ZOOM_RATIO;
        if(MOUSE_OR_TOUCH>0)
            cornerSize *= rTouch;
        flagHitCorner = ((p0.x-me.objData.x-width+cornerSize)- (me.objData.y+height- p0.y))>=0;
    }else
        flagHitCorner = false;
    flagInside = flagHit && !flagHitCorner;
    return new HitTestInfo(me, flagHit, flagInside, {hitCorner:flagHitCorner});
};

//
TextModelElement.prototype.isMatchForElement = function(refElement, options){
    var me = this;
    if(refElement.getType() != me.getType())
        return false;
    var flag = true;
    if(flag && refElement.isCheckText()){
        //ignore newline symbols for verifiable text elements
        var sRef = refElement.getCorrectText().replace(me.NEW_LINE_BEGINS_ENDS_REGULAR_EXPRESSION, "").replace(me.NEW_LINE_REGULAR_EXPRESSION, "\n");
        var aSRef = sRef.split("\n"), l = aSRef.length, i;
        var s = me.getText().replace(me.NEW_LINE_BEGINS_ENDS_REGULAR_EXPRESSION, "").replace(me.NEW_LINE_REGULAR_EXPRESSION, " ");
        s = miscFunctions.stripSpaces(s);
        for(i=0; i<l; i++)
            if(refElement.isCheckCase() ? (s==aSRef[i]) : (s.toLowerCase()==aSRef[i].toLowerCase()))
                break;
        flag = (i<l);
    }
    if(flag && refElement.isCheckColor())
        flag = refElement.getCorrectFontColor()==me.getFontColor();
    if(flag && refElement.isCheckFont())
        flag = refElement.getCorrectFontFace()==me.getFontFace();
    if(flag && refElement.isCheckSize())
        flag = refElement.getCorrectFontSize()==me.getFontSize();

    return flag;
};
/**
 * @constructor
 */
function BtextModelElement(_objResourceData){
    BtextModelElement.superclass.constructor.call(this, _objResourceData);
    var me = this;
    me.textField = new TextModelElement(_objResourceData);
    me.leaderLine = new PartLeaderLine(me);
    //
    //text color
    me.flagFillColored = true;
    //text frame
    me.flagLineColored = true;
}
extend(BtextModelElement, ModelElement);

BtextModelElement.prototype.typePrefix = ModelResource.prototype.TYPE_BTEXT;
BtextModelElement.prototype.familyPrefix = ModelResource.prototype.TYPE_BTEXTS;
BtextModelElement.prototype.className = ModelResource.prototype.CLASSID_BTEXT;
BtextModelElement.prototype.localizedNamePrefix = "Подпись ";

BtextModelElement.prototype.DEFAULT_LEADERLINE_WIDTH = 1;
BtextModelElement.prototype.DEFAULT_POINTER_DIAMETER = 4;
BtextModelElement.prototype.DEFAULT_LEADERLINE_HIT_WIDTH = 4;
BtextModelElement.prototype.DEFAULT_POINTER_HIT_DIAMETER = 6;

BtextModelElement.prototype.aMethodNameForProperty =
    miscFunctions.cloneObject(BtextModelElement.superclass.aMethodNameForProperty);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillColor", false, "getFontColor"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillColor", true, "setFontColor"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillAlpha", false, "getFontAlpha"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillAlpha", true, "setFontAlpha"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "lineColor", false, "getBorderColor"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "lineColor", true, "setBorderColor"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "lineAlpha", false, "getBorderAlpha"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "lineAlpha", true, "setBorderAlpha"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillColorCtrl", false, "getBackgroundColor"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillColorCtrl", true, "setBackgroundColor"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillAlphaCtrl", false, "getBackgroundAlpha"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fillAlphaCtrl", true, "setBackgroundAlpha"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fontSize", false, "getFontSize"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fontSize", true, "setFontSize"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fontFace", false, "getFontFace"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "fontFace", true, "setFontFace"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "horizontalAlign", false, "getHorizontalAlign"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "horizontalAlign", true, "setHorizontalAlign"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "editingMode", false, "isEditingMode"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "editingMode", true, "setEditingMode"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "lineCount", false, "getLineCount"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "characterBounds", false, "getCharacterBounds"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "textInputWidth", false, "getWidthTextField"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "textInputWidth", true, "setWidthTextField"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "textInputHeight", false, "getHeightTextField"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "textInputHeight", true, "setHeightTextField"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "text", false, "getText"
);
BtextModelElement.prototype.setMethodNameForProperty(
    BtextModelElement.prototype.aMethodNameForProperty, "text", true, "setText"
);

BtextModelElement.prototype.aPropretyNameMap = BtextModelElement.superclass.aPropretyNameMap.slice(0);
(function(){
    var a = BtextModelElement.prototype.aPropretyNameMap;
    a.splice(a.length, 0,
        ["XHandler", "xPointer", TYPE_NUMBER],
        ["YHandler", "yPointer", TYPE_NUMBER]
    );
})();

BtextModelElement.prototype.isMovableByMouse = function(){
    var me = this;
    if(!me.isMovable())
        return false;
    var hitDetails = me.getHitDetails();
    return (hitDetails != null && typeof hitDetails.flagLeaderLine == TYPE_BOOLEAN && hitDetails.flagLeaderLine);
};

BtextModelElement.prototype.getX = function(){
    return this.textField.getX();
};

BtextModelElement.prototype.setX = function(v){
    var me = this;
    var dXPointer = me.getXPointer() - me.textField.getX();
    me.textField.setX(v);
    me.setXPointer(v+dXPointer);
};

BtextModelElement.prototype.getY = function(){
    return this.textField.getY();
};

BtextModelElement.prototype.setY = function(v){
    var me = this;
    var dYPointer = me.getYPointer() - me.textField.getY();
    me.textField.setY(v);
    me.setYPointer(v+dYPointer);
};

BtextModelElement.prototype.getXTextField = function(){
    return this.textField.getX();
};

BtextModelElement.prototype.setXTextField = function(v){
    this.textField.setX(v);
};

BtextModelElement.prototype.getYTextField = function(){
    return this.textField.getY();
};

BtextModelElement.prototype.setYTextField = function(v){
    this.textField.setY(v);
};

BtextModelElement.prototype.getWidthTextField = function(){
    return this.textField.getWidth();
};

BtextModelElement.prototype.setWidthTextField = function(v){
    this.textField.setWidth(v);
};

BtextModelElement.prototype.getLineCount = function(){
    return this.textField.getLineCount();
};

BtextModelElement.prototype.getCharacterBounds = function(){
    return this.textField.getCharacterBounds();
};

BtextModelElement.prototype.getHeightTextField = function(){
    return this.textField.getHeight();
};

BtextModelElement.prototype.setHeightTextField = function(v){
    this.textField.setHeight(v);
};

BtextModelElement.prototype.getXPointer = function(){
    return this.objData.xPointer;
};

BtextModelElement.prototype.setXPointer = function(v){
    this.objData.xPointer = v;
};

BtextModelElement.prototype.getYPointer = function(){
    return this.objData.yPointer;
};

BtextModelElement.prototype.setYPointer = function(v){
    this.objData.yPointer = v;
};

BtextModelElement.prototype.getTextField = function(){
    return this.textField;
};

BtextModelElement.prototype.getLeaderLine = function(){
    return this.leaderLine;
};

/////////////////////TEXT PROPERTIES ARE ADDRESSED TO THE textField/////////////////////
BtextModelElement.prototype.getText = function(){
    return this.textField.getText();
};

BtextModelElement.prototype.setText = function(s){
    this.textField.setText(s);
};

BtextModelElement.prototype.getFontColor = function(){
    return this.textField.getFontColor();
};

BtextModelElement.prototype.setFontColor = function(v){
    this.textField.setFontColor(v);
};

BtextModelElement.prototype.getFontAlpha = function(){
    return this.textField.getFontAlpha();
};

BtextModelElement.prototype.setFontAlpha = function(v){
    this.textField.setFontAlpha(v);
};

BtextModelElement.prototype.getBorderColor = function(){
    return this.textField.getBorderColor();
};

BtextModelElement.prototype.setBorderColor = function(v){
    this.textField.setBorderColor(v);
};

BtextModelElement.prototype.getBorderAlpha = function(){
    return this.textField.getBorderAlpha();
};

BtextModelElement.prototype.setBorderAlpha = function(v){
    this.textField.setBorderAlpha(v);
};

BtextModelElement.prototype.getBackgroundColor = function(){
    return this.textField.getBackgroundColor();
};

BtextModelElement.prototype.setBackgroundColor = function(v){
    this.textField.setBackgroundColor(v);
};

BtextModelElement.prototype.getBackgroundAlpha = function(){
    return this.textField.getBackgroundAlpha();
};

BtextModelElement.prototype.setBackgroundAlpha = function(v){
    this.textField.setBackgroundAlpha(v);
};

BtextModelElement.prototype.getFontSize = function(){
    return this.textField.getFontSize();
};

BtextModelElement.prototype.setFontSize = function(v){
    this.textField.setFontSize(v);
};

BtextModelElement.prototype.getFontFace = function(){
    return this.textField.getFontFace();
};

BtextModelElement.prototype.setFontFace = function(s){
    this.textField.setFontFace(s);
};

BtextModelElement.prototype.getHorizontalAlign = function(){
    return this.textField.getHorizontalAlign();
};

BtextModelElement.prototype.setHorizontalAlign = function(s){
    this.textField.setHorizontalAlign(s);
};

//override
BtextModelElement.prototype.isHighlighted = function(){
    return this.flagHighlight;
};

//override
BtextModelElement.prototype.isEditingMode = function(){
    return this.textField.isEditingMode();
};

//
BtextModelElement.prototype.setEditingMode = function(flag){
    this.textField.setEditingMode(flag);
};

//
BtextModelElement.prototype.isTextModifiable = function(){
    return this.textField.isTextModifiable();
};

//
BtextModelElement.prototype.isHorizontalAlignModifiable = function(){
    var tF = this.textField;
    return tF.isSelected() && tF.isHorizontalAlignModifiable();
};

//override
BtextModelElement.prototype.setHighlighted = function(flag){
    var me = this;
    var hitDetails = me.getHitDetails();
    if(flag) {
        if(hitDetails != null){
            me.textField.setHighlighted(hitDetails.flagTextField);
            me.leaderLine.setHighlighted(hitDetails.flagLeaderLine ||hitDetails.flagPointer);
        }

    }else {
        me.textField.setHighlighted(false);
        me.leaderLine.setHighlighted(false);
    }
    BtextModelElement.superclass.setHighlighted.call(me, flag);
};

//override
BtextModelElement.prototype.setSelected = function(flag){
    var me = this;
    me.leaderLine.setSelected(flag);
    me.textField.setSelected(flag);
    BtextModelElement.superclass.setSelected.call(me, flag);
};

//override
BtextModelElement.prototype.setBlinking = function(flag){
    BtextModelElement.superclass.setBlinking.call(this, flag);
    var me = this;
    me.leaderLine.setBlinking(flag);
    me.leaderLine.setShowCorrect(false);
    me.leaderLine.setShowIncorrect(false);
    me.textField.setBlinking(flag);
    me.textField.setShowCorrect(false);
    me.textField.setShowIncorrect(false);
};

//override
BtextModelElement.prototype.setShowCorrect = function(flag){
    BtextModelElement.superclass.setShowCorrect.call(this, flag);
    var me = this;
    if(flag){
        me.leaderLine.setShowIncorrect(false);
        me.textField.setShowIncorrect(false);
    }
    me.leaderLine.setBlinking(flag);
    me.leaderLine.setShowCorrect(flag);
    me.textField.setBlinking(flag);
    me.textField.setShowCorrect(flag);
};

//override
BtextModelElement.prototype.setShowIncorrect = function(flag){
    BtextModelElement.superclass.setShowIncorrect.call(this, flag);
    var me = this;
    if(flag){
        me.leaderLine.setShowCorrect(false);
        me.textField.setShowCorrect(false);
    }
    me.leaderLine.setBlinking(flag);
    me.leaderLine.setShowIncorrect(flag);
    me.textField.setBlinking(flag);
    me.textField.setShowIncorrect(flag);
};

//override
BtextModelElement.prototype.getHitTestInfoForPoint = function(p0){
    var me = this;
    var flagHit;
    var flagHitText = false;
    var flagInside;
    var flagHitCorner;
    var leaderLineHtInfo = me.leaderLine.getHitTestInfoForPoint(p0);
    if(leaderLineHtInfo.isHit()){
        flagHit = true;
        flagInside = false;
        me.textField.setHitDetails({flagHit:false, flagInside:false});
    }else{
        var textFieldHtInfo = me.textField.getHitTestInfoForPoint(p0);
        flagHit = flagHitText = textFieldHtInfo.isHit();
        flagInside = textFieldHtInfo.isInside();
        flagHitCorner = textFieldHtInfo.getDetails().hitCorner;
        me.textField.setHitDetails({flagHit:flagHit, flagInside:flagInside, hitCorner:flagHitCorner});
    }
    var objLLDetails = leaderLineHtInfo.getDetails();
    me.leaderLine.setHitDetails(objLLDetails);
    var objDetails = {flagTextField:flagHitText};
    if(objLLDetails != null){
        objDetails.flagLeaderLine = objLLDetails.flagLeaderLine;
        objDetails.flagPointer = objLLDetails.flagPointer;
    }else{
        objDetails.flagLeaderLine = false;
        objDetails.flagPointer = false;
    }
    return new HitTestInfo(me, flagHit, flagInside, objDetails);
};


//formal override
BtextModelElement.prototype.setHitDetails = function(details){
    var me = this;
    me.hitDetails = details;
    if(details == null) {
        me.textField.setHitDetails(null);
        me.leaderLine.setHitDetails(null);
    }
};

//
BtextModelElement.prototype.fPositionsMatch = function(refElement, r){
    var me = this;
    var p = new Point(me.getXPointer(), me.getYPointer());
    if(typeof refElement[me.POINT_WITHIN_METHOD] == TYPE_FUNCTION)
        return refElement[me.POINT_WITHIN_METHOD](p);
    else {
        var refPoint =
            (refElement.getType() == ModelResource.prototype.TYPE_BTEXT) ?
                new Point(refElement.getXPointer(), refElement.getYPointer()) :
                new Point(refElement.getX(), refElement.getY());
        return p.distanceSquared(refPoint) <= r * r;
    }
};

//override
BtextModelElement.prototype.isMatchForElement = function(refElement, options){
    var me = this;
    if(refElement.getType() != me.getType())
        return false;
    var zoneElement =
        (typeof options != TYPE_UNDEFINED && typeof options.zoneElement != TYPE_UNDEFINED ) ?
            options.zoneElement : refElement;
    var flag = me.fPositionsMatch(zoneElement, zoneElement.getErrorZoneRadius());
    var refTextField = refElement.getTextField();
    if(flag && refTextField.isCheckText())
        flag = me.textField.isMatchForElement(refTextField, options);
    if(flag && refTextField.isCheckColor())
        flag = refTextField.getCorrectFontColor()==me.textField.getFontColor();
    return flag;
};
/**
 * @constructor
 */
function PartLeaderLine(parentElement){
    PartLeaderLine.superclass.constructor.call(this, parentElement, {});
    var me = this;
    me.objDataConst.borderWidth = me.DEFAULT_BORDER_WIDTH;
}
extend(PartLeaderLine, ElementPart);

PartLeaderLine.prototype.TOUCH_SIZE_FACTOR = 5;

PartLeaderLine.prototype.DEFAULT_BORDER_WIDTH = 1;
PartLeaderLine.prototype.DEFAULT_LEADERLINE_WIDTH = 1;
PartLeaderLine.prototype.DEFAULT_POINTER_DIAMETER = 4;
PartLeaderLine.prototype.DEFAULT_LEADERLINE_HIT_WIDTH = 4;
PartLeaderLine.prototype.DEFAULT_POINTER_HIT_DIAMETER = 6;

PartLeaderLine.prototype.getBorderWidth = function(){
    return this.objDataConst.borderWidth;
};

//override
PartLeaderLine.prototype.getHitTestInfoForPoint = function(p0){
    var me = this;
    var parentElement = me.parentElement;

    //check if leader line or point have been hit and set hit test details property correspondingly
    var xPointer = parentElement.getXPointer();
    var yPointer = parentElement.getYPointer();

    var dx = p0.x-xPointer;
    var dy = p0.y-yPointer;
    var r2 = BtextModelElement.prototype.DEFAULT_POINTER_HIT_DIAMETER;
    var rTouch = me.TOUCH_SIZE_FACTOR/ModelElement.prototype.ZOOM_RATIO;

    if(MOUSE_OR_TOUCH>0)
        r2 *= rTouch;

    r2 *= r2;
    var flagPointer = ((dx*dx+dy*dy)<r2);

    var flagLeaderLine;
    if(!flagPointer){
        var xTL = parentElement.getXTextField();
        var xBR = xTL+parentElement.getWidthTextField();
        var xTFCorner = (Math.abs(xTL-xPointer) < Math.abs(xBR-xPointer)) ? xTL : xBR;

        var pText = new Point(
            xTFCorner, parentElement.getYTextField()+parentElement.getHeightTextField()
        );
        var pPointer = new Point(xPointer, yPointer);
        var w = BtextModelElement.prototype.DEFAULT_LEADERLINE_HIT_WIDTH;
        if(MOUSE_OR_TOUCH>0)
            w *= rTouch;
        flagLeaderLine = miscFunctions.isPointOnSegment(p0, pPointer, pText, w);
    }else
        flagLeaderLine = false;

    var flagHit = flagLeaderLine || flagPointer;
    var flagInside = false;

    var objDetails;
    if(flagLeaderLine || flagPointer){
        objDetails = {};
        objDetails.flagLeaderLine = flagPointer ? false : flagLeaderLine;
        objDetails.flagPointer = flagPointer;
    }else
        objDetails = null;

    return new HitTestInfo(me, flagHit, flagInside, objDetails);
};